/******************************************************************************/
/* BAIChasing -   BattleFleet              */
/******************************************************************************/

#ifndef BAIChasing_H
#define BAIChasing_H
static const char baichasing_h_id[]="@(#) $Id: baichasing.h,v 1.9 2005/01/24 03:50:43 Oleksiy Balabay Exp $"; static const char* baichasing_h_id_id=baichasing_h_id;
/** \file baichasing.h
  \brief  BAIChasing  BattleFleet

     BAIChasing  BattleFleet
*/
#include <qdatetime.h>

#include "bai.h"

class BAIChasingTracks;
class BAICollisions;

class BAIChasing: public BAI {
  typedef struct BChasingProgramTuning {
    QDateTime dt;
    double a;
    double finalCourse;
    double v;
    double r;
  } BChasingProgramTuning;
public:
  BAIChasing(BAIs* parent, BattleObject* pursuier, BattleObject* evader,
    double distance);
  virtual ~BAIChasing();
  virtual void think();
  BattleObject* evader() const {
    return _evader;
  }
  static const QString AI_TYPE_CHASING;
  static const QString AI_PURSUIER;
  static const QString AI_EVADER;
  virtual QDomElement toXml(QDomDocument& doc) const;
  virtual bool setControlMode(ControlModes mode);
  virtual bool objectRemoved(BattleObject* o);
private:
//  void init();
  void thinkPF();
  void thinkCF();
//  void thinkB();
//  void thinkLJ();
  void thinkTT();
  void checkCollisions();
//  bool predictSteps();
  double course(double xE, double yE, double xP, double yP);
private:
  BattleObject* _evader;
//  double _distance;
//  BChasingProgramTuning _old, _new;
  double _y0;
private:
// static bool _initialized;

  BAIChasingTracks* _chasingTracksPF;
  BAIChasingTracks* _chasingTracksCF;
  BAICollisions* _collisions;
};

#endif // BAIChasing_H
