/******************************************************************************/
/* BallonHelp -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char ballonhelp_cpp_id[]="@(#) $Id: ballonhelp.cpp,v 1.1 2005/01/05 11:47:21 Oleksiy Balabay Exp $"; static const char* ballonhelp_cpp_id_id=ballonhelp_cpp_id;

#include <qsettings.h>

#include "ballonhelp.h"
#include "bapplication.h"
#include "bunitsconsts.h"

/** \file ballonhelp.cpp
  \brief  BallonHelp  BattleFleet (impl.)

     BallonHelp  BattleFleet
*/

/** \class BallonHelp
  \brief 


*/
const char *BallonHelp::S_OPTIONS_MISC = "Misc";
const char *BallonHelp::S_OPTIONS_MISC_SHOW_BALLON_HELP = "ShowBallonHelp";
const char *BallonHelp::BALLON_HELP = "BallonHelp";
const char *BallonHelp::BALLON_HELP_MODES = "Modes";
const char *BallonHelp::BALLON_HELP_DOCK_WINDOWS = "DockWindows";
const char *BallonHelp::BALLON_HELP_LINE_COLORS = "LineColors";
const char *BallonHelp::BALLON_HELP_EDITOR_MODES = "EditorModes";
const char *BallonHelp::BALLON_HELP_SELECTION = "Selection";
const char *BallonHelp::BALLON_HELP_AUTO_CONTROL = "AutoControl";

/** \brief 
*/
BallonHelp::BallonHelp(){

}

/** \brief 
*/
BallonHelp::~BallonHelp(){

}

bool BallonHelp::shouldBeShown(const char* message) const {
  if (!isAutoShow())
    return false;
  bool toShow = true;
  QSettings* settings = bApp->settings();
  settings->beginGroup(S_OPTIONS);
    settings->beginGroup(S_OPTIONS_MISC);
      settings->beginGroup(BALLON_HELP);
        toShow = settings->readBoolEntry(message, true);
      settings->endGroup();
    settings->endGroup();
  settings->endGroup();
  return toShow;
}

void BallonHelp::setShown(const char* message) {
  QSettings* settings = bApp->settings();
  settings->beginGroup(S_OPTIONS);
    settings->beginGroup(S_OPTIONS_MISC);
      settings->beginGroup(BALLON_HELP);
        settings->writeEntry(message, false);
      settings->endGroup();
    settings->endGroup();
  settings->endGroup();
}

void BallonHelp::reset() {
  QSettings* settings = bApp->settings();
  settings->beginGroup(S_OPTIONS);
    settings->beginGroup(S_OPTIONS_MISC);
      QStringList l = settings->entryList(BALLON_HELP);
      settings->beginGroup(BALLON_HELP);
      for(QStringList::const_iterator it = l.begin(); it != l.end(); it++) {
        settings->removeEntry(*it);
      }
      settings->endGroup();
    settings->endGroup();
  settings->endGroup();
}

void BallonHelp::setAutoShow(bool autoShow) {
  QSettings* settings = bApp->settings();
  settings->beginGroup(S_OPTIONS);
    settings->beginGroup(S_OPTIONS_MISC);
      settings->writeEntry(S_OPTIONS_MISC_SHOW_BALLON_HELP, autoShow);
    settings->endGroup();
  settings->endGroup();
}

bool BallonHelp::isAutoShow() const {
  bool rez = true;
  QSettings* settings = bApp->settings();
  settings->beginGroup(S_OPTIONS);
    settings->beginGroup(S_OPTIONS_MISC);
      rez = settings->readBoolEntry(S_OPTIONS_MISC_SHOW_BALLON_HELP, true);
    settings->endGroup();
  settings->endGroup();
  return rez;
}
