/******************************************************************************/
/* BAppState -   BattleFleet              */
/******************************************************************************/

#ifndef BAppState_H
#define BAppState_H
static const char bappstate_h_id[]="@(#) $Id: bappstate.h,v 1.6 2005/01/21 16:25:02 Oleksiy Balabay Exp $"; static const char* bappstate_h_id_id=bappstate_h_id;
/** \file bappstate.h
  \brief  BAppState  BattleFleet

     BAppState  BattleFleet
*/
#include <qstring.h>

#include "bapplication.h"

class Battle;
class BException;
class BFactoryPlay;
class BFactoryUndefined;
struct BattleLoadData;

class BAppState {
public:
  BAppState();
  Battle* battle() const;
  virtual ~BAppState();
  virtual void init(const BattleLoadData& loadData)  = 0;
  virtual BAppModes appMode() = 0;
protected:
  Battle* _battle;
};

class BAppStateUndefined: public BAppState {
  friend class BFactoryUndefined;
  BAppStateUndefined();
public:
  virtual ~BAppStateUndefined();
  virtual void init(const BattleLoadData& loadData) ;
  virtual BAppModes appMode();
};

class BAppStatePlay: public BAppState {
  friend class BFactoryPlay;
  BAppStatePlay();
public:
  virtual ~BAppStatePlay();
  virtual void init(const BattleLoadData& loadData) ;
  virtual BAppModes appMode();
protected:
  void initBattle(const BattleLoadData& loadData) ;
};

#endif // BAppState_H
