/******************************************************************************/
/* BattleEdit -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char battleedit_cpp_id[]="@(#) $Id: battleedit.cpp,v 1.13 2005/02/20 14:44:57 Oleksiy Balabay Exp $"; static const char* battleedit_cpp_id_id=battleedit_cpp_id;

#include "battleedit.h"
#include "bevent.h"
#include "beventsparser.h"
#include "bscenarioheader.h"
#include "bseamap.h"
#include "bships.h"

/** \file battleedit.cpp
  \brief  BattleEdit  BattleFleet (impl.)

     BattleEdit  BattleFleet
*/

/** \class BattleEdit
  \brief 


*/
/** \brief 
*/
BattleEdit::BattleEdit(const BattleLoadData& loadData)
:Battle(loadData){
  
}

/** \brief 
*/
BattleEdit::~BattleEdit(){

}

void BattleEdit::init() {
  BEventsParser evParser(scenarioHeader()->eventsFileName(), this);
  evParser.parse();
//  evParser.postEvents();
  _events->processEvents(battleInfo().modelTime);
  while (qApp->hasPendingEvents())
    qApp->processEvents();
  emit battleInfoChanged(battleInfo());
  setModified(false);
}

void BattleEdit::postEvent(BattleEvent* event) {
  _events->postEvent(event->event());
  addBattleInfoFlags(BattleFlags(0), true);
  _events->processEvents(battleInfo().modelTime);
  setModified(true);
  emit battleInfoChanged(battleInfo());
}

void BattleEdit::postEvent(BEvent* event) {
  BattleEvent* be = new BattleEvent(event);
  qApp->postEvent(this, be);
}

void BattleEdit::customEvent(QCustomEvent* e) {
  if (e->type() == BattleEventNumber) {
    BattleEvent* be = (BattleEvent*)e;
    postEvent(be);
  }
  else {
    Battle::customEvent(e);
  }
}

void BattleEdit::save() {
  const_cast<BScenarioHeader*>(scenarioHeader())->setBeginDate(
    battleInfo().modelTime);
  scenarioHeader()->save(scenarioHeader()->fileName());
  seaMap()->save(scenarioHeader()->mapFileName());
//  _events->save(scenarioHeader()->eventsFileName());
  ships()->save(scenarioHeader()->eventsFileName());
  emit saveAI(scenarioHeader()->aiFileName());
  setModified(false);
}

void BattleEdit::addShipsDbFile(const QString& fileName) {
  _scenarioHeader->addShipsFileName(fileName);
}

void BattleEdit::removeShipsDbFile(const QString& fileName) {
  _scenarioHeader->removeShipsFileName(fileName);
}

void BattleEdit::setModelTime(const QDateTime& dt) {
  const_cast<BattleInfo&>(battleInfo()).modelTime = dt;
  emit battleInfoChanged(battleInfo());
}
