/******************************************************************************/
/* BattleEdit -   BattleFleet              */
/******************************************************************************/

#ifndef BattleEdit_H
#define BattleEdit_H
static const char battleedit_h_id[]="@(#) $Id: battleedit.h,v 1.8 2005/01/05 11:47:22 Oleksiy Balabay Exp $"; static const char* battleedit_h_id_id=battleedit_h_id;
/** \file battleedit.h
  \brief  BattleEdit  BattleFleet

     BattleEdit  BattleFleet
*/
#include "battle.h"
#include "bcustomeventconsts.h"

class BattleEvent: public QCustomEvent {
public:
  BattleEvent(BEvent* event)
    :QCustomEvent(BattleEventNumber), _event(event) {
  }
  BEvent* event() const {
    return _event;
  }
private:
  BEvent* _event;
};

class BattleEdit: public Battle {
  Q_OBJECT
public:
  BattleEdit(const BattleLoadData& loadData);
  virtual ~BattleEdit();
  virtual void init();
  virtual void postEvent(BEvent* event);
  virtual void save();
  void addShipsDbFile(const QString& fileName);
  void removeShipsDbFile(const QString& fileName);
  void setModelTime(const QDateTime& dt);
private:
  void postEvent(BattleEvent* e);
protected:
  virtual void customEvent(QCustomEvent* e);
};

#endif // BattleEdit_H
