/******************************************************************************/
/* BattleObserver -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char battleobserver_cpp_id[]="@(#) $Id: battleobserver.cpp,v 1.6 2005/01/16 15:33:39 Oleksiy Balabay Exp $"; static const char* battleobserver_cpp_id_id=battleobserver_cpp_id;

#include <qwidget.h>

#include "battleobserver.h"
#include "battle.h"
#include "bevent.h"
#include "beventclear.h"
#include "beventgroup.h"
#include "bships.h"
#include "battleedit.h"

/** \file battleobserver.cpp
  \brief  BattleObserver  BattleFleet (impl.)

     BattleObserver  BattleFleet
*/

/** \class BattleObserver
  \brief 


*/
/** \brief 
*/
BattleObserver::BattleObserver(Battle* battle, QObject* parent, 
  const char* name):QObject(parent, name), _battle(battle) {
  _viewWidget = 0;
  if (battle) {
    connect(battle, SIGNAL(battleInfoChanged(const BattleInfo&)),
      this, SLOT(slotBattleInfoChanged(const BattleInfo&)));
  }
}

/** \brief 
*/
BattleObserver::~BattleObserver(){

}

QWidget* BattleObserver::viewWidget() const {
  return _viewWidget;
}

void BattleObserver::slotBattleInfoChanged(const BattleInfo& /* info */) {
  ;
}

void BattleObserver::slotAboutToQuitBattle() {
  ;
}

void BattleObserver::postEvent(BEvent* e, bool clearEvents, 
  bool removeFromParentControl) {
  if (clearEvents) {
    if (!e->objectName().isEmpty()) {
      BEvent* clearEvent = new BEventClear(e->objectName(), e->date());
      _battle->postEvent(clearEvent);
    }
    else {
//      qDebug("Attempt to clear events for empty object");
    }
  }
  if (removeFromParentControl) {
    if (!e->objectName().isEmpty()) {
      BattleObject* bo =_battle->ships()->find(e->objectName());
      if (!(bo && (bo->parent()->name() == _battle->ships()->name()))) {
        BEvent* rEvent = new BEventGroupAdd(e->objectName(), 
        _battle->ships()->name(), _battle, e->date());
        _battle->postEvent(rEvent);
      }
    }
    else {
//      qDebug("Attempt to remove for empty object");
    }
  }
  if ((_battle->battleInfo().state != Running)&&
    (e->date() == _battle->battleInfo().modelTime)) {
    BattleEvent* be = new BattleEvent(e);
    qApp->postEvent(_battle, be);
  }
  else {
    _battle->postEvent(e);
  }
}
