/******************************************************************************/
/* BattleObserver -   BattleFleet              */
/******************************************************************************/

#ifndef BattleObserver_H
#define BattleObserver_H
static const char battleobserver_h_id[]="@(#) $Id: battleobserver.h,v 1.3 2004/07/05 16:33:40 Oleksiy Balabay Exp $"; static const char* battleobserver_h_id_id=battleobserver_h_id;
/** \file battleobserver.h
  \brief  BattleObserver  BattleFleet

     BattleObserver  BattleFleet
*/
#include <qobject.h>

struct BattleInfo;
class Battle;
class QWidget;
class BEvent;

class BattleObserver: public QObject {
  Q_OBJECT
public:
  BattleObserver(Battle* battle, QObject* parent, const char* name);
  virtual ~BattleObserver();
  virtual QWidget* viewWidget() const;
  virtual void init() {};
  void postEvent(BEvent* e, bool clearEvents = false, 
    bool removeFromParentControl = false);
public slots:
  virtual void slotBattleInfoChanged(const BattleInfo& info);
  virtual void slotAboutToQuitBattle();
protected:
  QWidget* _viewWidget;
  Battle* _battle;
};

#endif // BattleObserver_H
