/******************************************************************************/
/* BCanvasConnection -                 */
/******************************************************************************/

#ifndef BCanvasConnection_H
#define BCanvasConnection_H
static const char bcanvasconnection_h_id[]="@(#) $Id: bcanvasconnection.h,v 1.2 2004/10/10 10:18:20 Oleksiy Balabay Exp $"; static const char* bcanvasconnection_h_id_id=bcanvasconnection_h_id;
/** \file bcanvasconnection.h
  \brief  BCanvasConnection  

     BCanvasConnection  
*/
#include <qcanvas.h>

#include "bcanvasship.h"

class BCanvasConnection: public QCanvasLine {
public:
  BCanvasConnection(QCanvasItem* from, QCanvasItem* to, QCanvas *canvas);
  virtual ~BCanvasConnection();
  virtual void drawShape(QPainter &painter);
  virtual QPointArray areaPoints() const;
  virtual void updatePoints();
  virtual void popup(const QPoint p);
protected:
  QCanvasItem* _from;
  QCanvasItem* _to;
};

class BAIChasing;
class BCentral;

class BCanvasChasingConnection: public BCanvasConnection {
public:
  BCanvasChasingConnection(BCentral* central, BAIChasing* ai, 
    BCanvasShip* from, BCanvasShip* to, QCanvas *canvas);
  virtual ~BCanvasChasingConnection();
  BCanvasShip* from() const {
    return dynamic_cast<BCanvasShip*>(_from);
  }
  BCanvasShip* to() const {
    return dynamic_cast<BCanvasShip*>(_to);
  }
  virtual void popup(const QPoint p);
  virtual void updateMode();
protected:
  BAIChasing* _ai;
  BCentral* _central;
};

#endif // BCanvasConnection_H
