/******************************************************************************/
/* BCanvasShip -   BattleFleet              */
/******************************************************************************/

#ifndef BCanvasShip_H
#define BCanvasShip_H
static const char bcanvasship_h_id[]="@(#) $Id: bcanvasship.h,v 1.9 2005/01/16 15:33:39 Oleksiy Balabay Exp $"; static const char* bcanvasship_h_id_id=bcanvasship_h_id;
/** \file bcanvasship.h
  \brief  BCanvasShip  BattleFleet

     BCanvasShip  BattleFleet
*/
#include <qcanvas.h>
#include <qdatetime.h>

#include <list>

class QPixmap;
class BShip;
class Battle;
class BCoordTransformer;

class BCanvasShip: public QCanvasEllipse {
public:
  BCanvasShip(const BCoordTransformer* coordTransformer, BShip* ship, 
    const Battle* battle, QCanvas* canvas);
  virtual ~BCanvasShip();
  void setAngle(const double angle);
  void setAdvanceDateTime(const QDateTime& dt);
  virtual void advance(int phase);
  BShip* ship() const;
protected:
  virtual void drawShape(QPainter& p);
private:
  virtual void preparePixmap();
  void drawHandle(QPainter &painter, const QPoint &center);
private:
  BShip* _ship;
  const Battle* _battle;
  QPixmap _pm;
  double _angle;
  const BCoordTransformer* _coordTransformer;
  QDateTime _advanceDateTime;
  int w1, h1;
  int _side;
private:
  static int _z;
};

typedef std::list<BCanvasShip*> BCanvasShips;

#endif // BCanvasShip_H
