/******************************************************************************/
/* BCentralEdit -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bcentraledit_cpp_id[]="@(#) $Id: bcentraledit.cpp,v 1.8 2005/02/15 16:43:34 Oleksiy Balabay Exp $"; static const char* bcentraledit_cpp_id_id=bcentraledit_cpp_id;

#include <qdragobject.h>

#include "bcentraledit.h"
#include "bprogramfactory.h"
#include "beventprogram.h"
#include "beventgroup.h"
#include "bobservercentral.h"
#include "battle.h"
#include "bships.h"
#include "bseamap.h"
#include "bapplication.h"
#include "bunitsconsts.h"

/** \file bcentraledit.cpp
  \brief  BCentralEdit  BattleFleet (impl.)

     BCentralEdit  BattleFleet
*/

/** \class BCentralEdit
  \brief 


*/
BCentralEdit::BCentralEdit(BObserverCentral* observer, 
  QWidget* parent, const char* name)
  :BCentral(observer, parent, name) {
  setAcceptDrops(true);
}

BCentralEdit::~BCentralEdit() {
}

void BCentralEdit::dragEnterEvent(QDragEnterEvent* e) {
  if (QTextDrag::canDecode(e)) {
    QString name;
    QTextDrag::decode(e, name);
    QStringList l = QStringList::split("\t", name);
    for (QStringList::const_iterator it = l.begin(); it != l.end(); it++) {
      if (!_battle->ships()->unUsedShips()->find(*it)) {
        e->accept(false);
        return;
      }
    }
    e->accept(true);
    return;
  }
  BCentral::dragEnterEvent(e);
}

void BCentralEdit::dropEvent(QDropEvent* e) {
  if (QTextDrag::canDecode(e)) {
    QString name;
    QTextDrag::decode(e, name);
    double delta = BUnitsConverter::degreesFromMiles(0.2);
    int i = 0;
//    QDateTime dt = _battle->battleInfo().modelTime;
    QStringList l = QStringList::split("\t", name);
    for (QStringList::const_iterator it = l.begin(); it != l.end(); it++) {
      BattleObject* bo = _battle->ships()->unUsedShips()->find(*it);
      if (bo == 0) {
        bApp->log(tr("Unknown object dropped: '%1'. Skipped").arg(*it));
        continue;
      }
      BEventGroupAdd* ev = new BEventGroupAdd(
        bo->name(), _battle->ships()->name(), _battle);
      _observer->postEvent(ev);

      QPoint point = viewportToContents(e->pos());
      BMapPoint pnt = _coordTransformer->pointToMap(point);
      BProgram* p = BProgramFactory::createStandByProgram(
        pnt.first, pnt.second-i*delta, _battle);
      BEvent* evp = new BEventProgram(p, bo->name());
      _observer->postEvent(evp);
      i++;
    }
  }
}

void BCentralEdit::slotBattleInfoChanged(const BattleInfo& battleInfo) {
  BCoordinates oldC = coordTransformer()->originalCoordinates();
  BCoordinates newC = _battle->seaMap()->originalCoordinates();
  if (oldC != newC) {
    showNewCanvas(newC);
    return;
  }
//  if (battleInfo.flags & BFShips) {
//    showNewCanvas(_coordTransformer->currentCoordinates());
//    return;
//  }
  BCentral::slotBattleInfoChanged(battleInfo);
}
