/******************************************************************************/
/* BCollisions -                 */
/******************************************************************************/

#ifndef BCollisions_H
#define BCollisions_H
static const char bcollisions_h_id[]="@(#) $Id: bcollisions.h,v 1.1 2004/10/18 15:02:05 Oleksiy Balabay Exp $"; static const char* bcollisions_h_id_id=bcollisions_h_id;
/** \file bcollisions.h
  \brief  BCollisions  

     BCollisions  
*/
#include <vector>
#include <map>

class Battle;
class QDateTime;

#include "battleobject.h"
#include "battleobserver.h"

class BCollisions: public BattleObserver {
  Q_OBJECT
public:
  typedef std::pair<BattleObject*, BattleObject*> Collision;
  typedef std::vector<Collision> Collisions;
public:
  BCollisions(Battle* battle, QObject* parent, const char* name);
  virtual ~BCollisions();
  Collisions checkObjects(const QDateTime& t);
  Collisions checkObject(const QDateTime& t, BattleObject* a);
  bool checkPair(const QDateTime& t, BattleObject* a, BattleObject* b);
private:
  Collisions checkObjectImpl(const QDateTime& t, BattleObject* a, 
    BattleObjects::const_iterator b, BattleObjects::const_iterator e);
  bool checkPairImpl(const QDateTime& t,
    BattleObject* a, BattleObject* b, double y0);
};

#endif // BCollisions_H
