/******************************************************************************/
/* BControlMove -   BattleFleet              */
/******************************************************************************/

#ifndef BControlMove_H
#define BControlMove_H
static const char bcontrolmove_h_id[]="@(#) $Id: bcontrolmove.h,v 1.6 2005/01/24 03:50:43 Oleksiy Balabay Exp $"; static const char* bcontrolmove_h_id_id=bcontrolmove_h_id;
/** \file bcontrolmove.h
  \brief  BControlMove  BattleFleet

     BControlMove  BattleFleet
*/

#include <qtimer.h>

#include "bcontrolmovebase.h"
#include "bai.h"

class BCoordinateEdit;
class QDoubleValidator;
class BattleObject;
class BattleObserver;

class BControlMove: public BControlMoveBase {
  Q_OBJECT
public:
  BControlMove(BattleObserver* observer, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  virtual ~BControlMove();
public slots:
  void setActiveObject(BattleObject* o);
protected:
  void mousePressEvent(QMouseEvent* e);
private slots:
  virtual void slotCourseChange(int deg);
  virtual void slotSpeedChange(int knots_10);
  virtual void slotCourseChange(int deg, int min, int sec);
  virtual void slotSpeedChange(const QString& knots);
  virtual void slotSet();
  void slotTimeout();
signals:
  void changeControlMode(const BAI::ControlModes mode, BattleObject* object);
private:
//  BCoordinateEdit* _course;
  QDoubleValidator* _speedValidator;
  BattleObject* _o;
  BattleObserver* _observer;
  QTimer _timer;
};

#endif // BControlMove_H
