/******************************************************************************/
/* BControlMoveView -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bcontrolmoveview_cpp_id[]="@(#) $Id: bcontrolmoveview.cpp,v 1.6 2005/04/03 14:21:02 Oleksiy Balabay Exp $"; static const char* bcontrolmoveview_cpp_id_id=bcontrolmoveview_cpp_id;

#include <qwhatsthis.h>

#include "bcontrolmoveview.h"
#include "bcontrolmove.h"
#include "buistate.h"
#include "bgroupview.h"

/** \file bcontrolmoveview.cpp
  \brief  BControlMoveView  BattleFleet (impl.)

     BControlMoveView  BattleFleet
*/

/** \class BControlMoveView
  \brief 


*/
const char* B_CONTROL_MOVE_VIEW = 
  QT_TRANSLATE_NOOP("BControlMoveView", "Move Control");

/** \brief 
*/
BControlMoveView::BControlMoveView(BattleObserver* observer, 
  QWidget* parent, const char* name):QDockWindow(parent, name),
  _observer(observer) {
  QWhatsThis::add(this, tr(
    "<b>%1</b><br><br>"
    "Use this window to send commands to the active ship or to the active group. "
    "The active object is highlighted with <b><font color=green>green</font></b> in the <b>%2</b> window. "
    "Specify the angle to turn (<b>not</b> the final course) and the new speed. "
    "For the group the turn type is also available: 'simulteneous' or 'in succession'. "
    "Negative values of the turn angle means turn to the left (to port), "
    "positive ones - to the right (to starboard)").arg(tr(B_CONTROL_MOVE_VIEW)).arg(
    qApp->translate("BGroupView", B_GROUP_VIEW))
  );

  _view = new BControlMove(observer, this, "controlmove");

  setWidget(_view);
  setCloseMode(Always);
  setMovingEnabled(true);
  setCaption(tr(B_CONTROL_MOVE_VIEW));
  _view->show();
}

/** \brief 
*/
BControlMoveView::~BControlMoveView(){

}

void BControlMoveView::slotSelectionChanged(
  const BUiSelectionInfo& selectionInfo) {
  _view->setActiveObject(selectionInfo.activeObject);
}

QObject* BControlMoveView::view() const {
  return _view;
}
