/******************************************************************************/
/* BCoordinateEdit -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bcoordinateedit_cpp_id[]="@(#) $Id: bcoordinateedit.cpp,v 1.2 2004/06/26 17:06:46 Oleksiy Balabay Exp $"; static const char* bcoordinateedit_cpp_id_id=bcoordinateedit_cpp_id;

#include <qspinbox.h>

#include "bcoordinateedit.h"
#include "bunitsconsts.h"

/** \file bcoordinateedit.cpp
  \brief  BCoordinateEdit  BattleFleet (impl.)

     BCoordinateEdit  BattleFleet
*/

/** \class BCoordinateEdit
  \brief 


*/
/** \brief 
*/
BCoordinateEdit::BCoordinateEdit(double deg, 
  QWidget* parent, const char* name, WFlags fl):BCoordinateEditBase(
  parent, name, fl){
  setValue(deg);
}

BCoordinateEdit::BCoordinateEdit(int deg, int min, int sec,
  QWidget* parent, const char* name, WFlags fl):BCoordinateEditBase(
  parent, name, fl){
  setValue(deg, min, sec);
}

BCoordinateEdit::BCoordinateEdit(QWidget* parent, const char* name, 
  WFlags fl):BCoordinateEditBase(parent, name, fl){
  setValue(0,0,0);
}

/** \brief 
*/
BCoordinateEdit::~BCoordinateEdit(){

}

void BCoordinateEdit::setValue(double deg) {
  int d;
  int m;
  int s;
  int sign;
  BUnitsConverter::angle(deg, &d, &m, &s, 0, &sign);
  d = sign*(d%360);
  setValue(d, m, s);
}

void BCoordinateEdit::setValue(int deg, int min, int sec) {
  deg = deg%360;
  _deg->setValue(deg);
  _min->setValue(min);
  _sec->setValue(sec);
}

void BCoordinateEdit::valueChangedInternal() {
  emit valueChanged(_deg->value(), _min->value(), _sec->value());
  emit valueChanged(value());
}

int BCoordinateEdit::degrees() const {
  return _deg->value();
}

int BCoordinateEdit::minutes() const {
  return _min->value();
}

int BCoordinateEdit::seconds() const {
  return _sec->value();
}

double BCoordinateEdit::value() const {
  int sign = (_deg->value() > 0)?1:-1;
  double d = (fabs(_deg->value())+
    _min->value()/60.0 + 
    _sec->value()/(60.0*60.0))*sign;
  return d;
}

void BCoordinateEdit::setDegreesRange(int degMin, int degMax) {
  _deg->setMinValue(degMin);
  _deg->setMaxValue(degMax);
}
