/******************************************************************************/
/* BDateEdit -     (impl.)            */
/******************************************************************************/
static const char bdateedit_cpp_id[]="@(#) $Id: bdateedit.cpp,v 1.1 2004/10/10 10:18:20 Oleksiy Balabay Exp $"; static const char* bdateedit_cpp_id_id=bdateedit_cpp_id;

#include <qlabel.h>
#include <qdatetimeedit.h>
#include <qslider.h>
#include <qlayout.h>

#include "bdateedit.h"

/** \file bdateedit.cpp
  \brief  BDateEdit   (impl.)

     BDateEdit  
*/

/** \class BDateEdit
  \brief 


*/
/** \brief 
*/
BDateEdit::BDateEdit(QWidget* parent, const char* name)
:QWidget(parent, name) {
  QHBoxLayout* l1 = new QHBoxLayout;
  _min = new QLabel(this, "minDate");
  l1->addWidget(_min);
  l1->addStretch(1);
  _dtEdit = new QDateTimeEdit(this, "dtEdit");
  l1->addWidget(_dtEdit);
  l1->addStretch(1);
  _max = new QLabel(this, "maxDate");
  l1->addWidget(_max);

  QVBoxLayout* mainLayout = new QVBoxLayout(this);
  _slider = new QSlider(Horizontal, this);
  mainLayout->addWidget(_slider);
  mainLayout->addLayout(l1);
  mainLayout->setMargin(11);
  QDateTime dt = QDateTime::currentDateTime();
  setInterval(dt, dt, dt);
  connect(_slider, SIGNAL(valueChanged(int)), this, 
    SLOT(sliderValueChanged(int)));
  connect(_dtEdit, SIGNAL(valueChanged(const QDateTime&)), this, 
    SLOT(editValueChanged(const QDateTime&)));
}

/** \brief 
*/
BDateEdit::~BDateEdit(){

}

QDateTime BDateEdit::selectedDate() const {
  return _dtEdit->dateTime();
}
void BDateEdit::setInterval(const QDateTime& dtMin, const QDateTime& dtMax,
  const QDateTime& dtSelected) {
  _dtMin = dtMin;
  _dtMax = dtMax;
  _min->setText(dtMin.toString());
  _max->setText(dtMax.toString());
  if (dtMin >= dtMax)
    setEnabled(false);
  else
    setEnabled(true);
  QDateTime dt = dtSelected;
  if (dtMin > dt)
    dt = dtMin;
  if (dtMax < dt)
    dt = dtMax;
  _dtEdit->setDateTime(dt);
  int daysInterval = _dtMin.daysTo(_dtMax);
  _daysScale = ( daysInterval >= 100);
  if (isEnabled()) {
    if (_daysScale) {
      _slider->setRange(0, daysInterval);
      _slider->setLineStep(1);
      _slider->setPageStep(daysInterval/10);
    }
    else {
      int secsInterval = _dtMin.secsTo(_dtMax);
      _slider->setRange(0, secsInterval);
      _slider->setLineStep(1);
      _slider->setPageStep(secsInterval/10);
    }
  }
}

void BDateEdit::sliderValueChanged(int v) {
  _dtEdit->setDateTime(toDateTime(v));
}

void BDateEdit::editValueChanged(const QDateTime& d) {
  QDateTime n = d;
  if (d>_dtMax)
    n = _dtMax;
  if (n<_dtMin)
    n = _dtMin;
  _slider->setValue(fromDateTime(n));
  _dtEdit->blockSignals(true);
  if (d != n)
    _dtEdit->setDateTime(n);
  _dtEdit->blockSignals(false);
}

int BDateEdit::fromDateTime(const QDateTime& d) {
  if (_daysScale) {
    return _dtMin.daysTo(d);
  }
  else {
    return _dtMin.secsTo(d);
  }
}

QDateTime BDateEdit::toDateTime(const int v) {
  if (_daysScale) {
    return _dtMin.addDays(v);
  }
  else {
    return _dtMin.addSecs(v);
  }
}
