/******************************************************************************/
/* BDateEdit -                 */
/******************************************************************************/

#ifndef BDateEdit_H
#define BDateEdit_H
static const char bdateedit_h_id[]="@(#) $Id: bdateedit.h,v 1.1 2004/10/10 10:18:20 Oleksiy Balabay Exp $"; static const char* bdateedit_h_id_id=bdateedit_h_id;
/** \file bdateedit.h
  \brief  BDateEdit  

     BDateEdit  
*/
#include <qwidget.h>
#include <qdatetime.h>

class QDateTimeEdit;
class QSlider;
class QLabel;

class BDateEdit: public QWidget {
  Q_OBJECT
public:
  BDateEdit(QWidget* parent, const char* name = 0);
  virtual ~BDateEdit();
  QDateTime selectedDate() const;
public slots:
  void setInterval(const QDateTime& dtMin, const QDateTime& dtMax,
    const QDateTime& dtSelected);
private slots:
  void sliderValueChanged(int v);
  void editValueChanged(const QDateTime& d);
  int fromDateTime(const QDateTime& d);
  QDateTime toDateTime(const int v);
private:
  QDateTimeEdit* _dtEdit;
  QSlider* _slider;
  QLabel* _min;
  QLabel* _max;
  QDateTime _dtMin;
  QDateTime _dtMax;
  bool _daysScale;
};

#endif // BDateEdit_H
