/******************************************************************************/
/* BDomHandler -                 */
/******************************************************************************/

#ifndef BDomHandler_H
#define BDomHandler_H
static const char bdomhandler_h_id[]="@(#) $Id: bdomhandler.h,v 1.1 2004/10/02 03:56:56 Oleksiy Balabay Exp $"; static const char* bdomhandler_h_id_id=bdomhandler_h_id;
/** \file bdomhandler.h
  \brief  BDomHandler  

     BDomHandler  
*/
#include <qxml.h>
#include <qdom.h>

class BDomHandler : public QXmlDefaultHandler
{
public:
    BDomHandler( QDomDocument* d, bool namespaceProcessing );
    virtual ~BDomHandler();

    // content handler
    virtual bool endDocument();
    virtual bool startElement( const QString& nsURI, const QString& localName, const QString& qName, const QXmlAttributes& atts );
    virtual bool endElement( const QString& nsURI, const QString& localName, const QString& qName );
    virtual bool characters( const QString& ch );
    virtual bool processingInstruction( const QString& target, const QString& data );
    virtual bool skippedEntity( const QString& name );

    // error handler
    virtual bool fatalError( const QXmlParseException& exception );

    // lexical handler
    virtual bool startCDATA();
    virtual bool endCDATA();
    virtual bool startEntity( const QString & );
    virtual bool endEntity( const QString & );
    virtual bool startDTD( const QString& name, const QString& publicId, const QString& systemId );
    virtual bool comment( const QString& ch );

    // decl handler
    virtual bool externalEntityDecl( const QString &name, const QString &publicId, const QString &systemId ) ;

    // DTD handler
    virtual bool notationDecl( const QString & name, const QString & publicId, const QString & systemId );
    virtual bool unparsedEntityDecl( const QString &name, const QString &publicId, const QString &systemId, const QString &notationName ) ;

    QString errorMsg;
    int errorLine;
    int errorColumn;

protected:
    QDomDocument *doc;
    QDomNode node;
    QString entityName;
    bool cdata;
    bool nsProcessing;
};

#endif // BDomHandler_H
