/******************************************************************************/
/* BEventClear -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char beventclear_cpp_id[]="@(#) $Id: beventclear.cpp,v 1.2 2004/08/08 15:20:36 Oleksiy Balabay Exp $"; static const char* beventclear_cpp_id_id=beventclear_cpp_id;

#include "beventclear.h"
#include "bapplication.h"
#include "battle.h"
#include "battleobject.h"

/** \file beventclear.cpp
  \brief  BEventClear  BattleFleet (impl.)

     BEventClear  BattleFleet
*/

/** \class BEventClear
  \brief 


*/
const QString BEventClear::BE_EVENT_TYPE_CLEAR = "Clear";

void BEventClear::exec() {
  BEvents* evnts = bApp->battle()->_events;
  BattleObject* bo = 0;
  try {
    bo = object();
  }
  catch (BNoObjectException&) {
  }
  if (bo) {
    BattleObjects bos = bo->objs(BattleObject::AllSelectionType);
    for(BattleObjects::const_iterator it = bos.begin(); it != bos.end(); it++) {
      evnts->clear((*it)->name(), date());
    }
  }
  else {
    evnts->clear(objectName(), date());
  }
}

QDomElement BEventClear::toXml(QDomDocument& doc) const {
  QDomElement e = BEvent::toXml(doc);
  e.setAttribute(BEvent::BE_EVENT_TYPE, BE_EVENT_TYPE_CLEAR);
  return e;
}

QString BEventClear::description() const {
  return qApp->translate("BEventClear", 
    "Remove all events for '%1' and childrens starting from '%2'").arg(
    objectName()).arg(date().toString());
}
