/******************************************************************************/
/* BEventCollision -     (impl.)            */
/******************************************************************************/
static const char beventcollision_cpp_id[]="@(#) $Id: beventcollision.cpp,v 1.1 2004/10/18 15:02:05 Oleksiy Balabay Exp $"; static const char* beventcollision_cpp_id_id=beventcollision_cpp_id;

#include "beventcollision.h"
#include "bapplication.h"
#include "bdomutils.h"

/** \file beventcollision.cpp
  \brief  BEventCollision   (impl.)

     BEventCollision  
*/

/** \class BEventCollision
  \brief 


*/
const QString BEventCollision::BE_EVENT_TYPE_COLLISION = "Collision";
const QString BEventCollision::SECOND = "Second";

/** \brief 
*/
BEventCollision::BEventCollision(const QString& objectName, 
  const QDateTime& dt):BEvent(objectName, dt){

}

BEventCollision::BEventCollision(const QString& objectName, 
  const QString& secondName, Battle* battle, const QDateTime& dt)
  :BEvent(objectName, dt), _secondName(secondName), _battle(battle) {
}

/** \brief 
*/
BEventCollision::~BEventCollision(){

}

void BEventCollision::exec() {
  bApp->log(description());
}

void BEventCollision::parse(const QDomElement& element, Battle* battle) {
  setEventFlags(eventFlagFromString(
    BDomUtils::stringAttribute(element, EVENT_FLAGS)));
  _secondName = BDomUtils::stringAttribute(element, SECOND);
}

QDomElement BEventCollision::toXml(QDomDocument& doc) const {
  QDomElement e = BEvent::toXml(doc);
  e.setAttribute(BEvent::BE_EVENT_TYPE, BE_EVENT_TYPE_COLLISION);
  e.setAttribute(SECOND, _secondName);
  return e;
}

QString BEventCollision::description() const {
  return qApp->translate("BEventCollision", 
    "Date:%1. '%2' collides with '%3'").arg(date().toString()).arg(
    objectName()).arg(_secondName);
}
