/******************************************************************************/
/* BEventCollision -                 */
/******************************************************************************/

#ifndef BEventCollision_H
#define BEventCollision_H
static const char beventcollision_h_id[]="@(#) $Id: beventcollision.h,v 1.1 2004/10/18 15:02:05 Oleksiy Balabay Exp $"; static const char* beventcollision_h_id_id=beventcollision_h_id;
/** \file beventcollision.h
  \brief  BEventCollision  

     BEventCollision  
*/
#include "bevent.h"

class BEventCollision: public BEvent {
public:
  BEventCollision(const QString& objectName, const QString& secondName, 
    Battle* battle, const QDateTime& dt);
  BEventCollision(const QString& objectName = "", 
  const QDateTime& dt = QDateTime());
  virtual ~BEventCollision();
  virtual void exec();
  virtual void parse(const QDomElement& element, Battle* battle); 
  virtual QDomElement toXml(QDomDocument& doc) const;
  virtual QString description() const;
public:
  static const QString BE_EVENT_TYPE_COLLISION;
  static const QString SECOND;
private:
  QString _secondName;
  Battle* _battle;
};

#endif // BEventCollision_H
