/******************************************************************************/
/* BEventProgram -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char beventprogram_cpp_id[]="@(#) $Id: beventprogram.cpp,v 1.10 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* beventprogram_cpp_id_id=beventprogram_cpp_id;

#include "beventprogram.h"
#include "bprogram.h"
#include "battleobject.h"
#include "bships.h"
#include "bdomutils.h"
#include "battle.h"
#include "bprogramfactory.h"

/** \file beventprogram.cpp
  \brief  BEventProgram  BattleFleet (impl.)

     BEventProgram  BattleFleet
*/

/** \class BEventProgram
  \brief 


*/
const QString BEventProgram::BE_EVENT_TYPE_PROGRAM = "Program";
/** \brief 
*/
BEventProgram::BEventProgram(const QString& objectName, const QDateTime& dt)
throw()  :BEvent(objectName, dt), _program(0) {

}

/** \brief 
*/
BEventProgram::~BEventProgram(){
  if (_program)
    delete _program;
}

void BEventProgram::exec() {
  _program->setProgramFlags(eventFlags());
  object()->setProgram(_program, date());
  QDomDocument doc;
  _savedProgram = _program->toXml(doc);
  _program = 0;
}

void BEventProgram::parse(const QDomElement& element, Battle* battle) {
  setEventFlags(eventFlagFromString(
    BDomUtils::stringAttribute(element, EVENT_FLAGS)));
//  QString shp = BDomUtils::stringAttribute(element, BE_EVENT_OBJECT);
//  _ship = battle->ships()->find(shp);
//  if (0 == _ship) {
//    throw BConfigException(__FILE__, __LINE__, qApp->translate("BEventProgram", 
//      "Unknown battle object specified: '%1'").arg(shp));
//  }
  bool programFound = false;
  QDomNode n = element.firstChild();
  while( !n.isNull() ) {
    QDomElement e1 = n.toElement(); // try to convert the node to an element.
    n = n.nextSibling();
    if( !e1.isNull() ) { // the node was really an element.
      if (e1.tagName() == BProgram::PROGRAM) {
        _program = BProgramFactory::create(e1, battle);
        programFound = true;
        break;
      }
    }
  }
  if (!programFound) {
    BDomUtils::elementDoesNotExist(BProgram::PROGRAM);
  }
}

BEventProgram::BEventProgram(BProgram* program, const QString& objectName, 
  const QDateTime& dt ) throw():BEvent(objectName, dt), 
  _program(program) {
}

QDomElement BEventProgram::toXml(QDomDocument& doc) const {
  QDomElement e = BEvent::toXml(doc);
  e.setAttribute(BEvent::BE_EVENT_TYPE, BE_EVENT_TYPE_PROGRAM);
  e.appendChild(_program?_program->toXml(doc):_savedProgram);
  return e;
}

QString BEventProgram::description() const {
  return qApp->translate("BEventGroupCreate",
    "Set program for object '%1'").arg(objectName());
}

