/******************************************************************************/
/* BEventSeaMap -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char beventseamap_cpp_id[]="@(#) $Id: beventseamap.cpp,v 1.5 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* beventseamap_cpp_id_id=beventseamap_cpp_id;

#include "beventseamap.h"
#include "bapplication.h"
#include "battle.h"

/** \file beventseamap.cpp
  \brief  BEventSeaMap  BattleFleet (impl.)

     BEventSeaMap  BattleFleet
*/

/** \class BEventSeaMap
  \brief 


*/
/** \brief 
*/
const QString BEventSeaMap::BE_EVENT_TYPE_SEAMAP = "SeaMap";
/** \brief 
*/
BEventSeaMap::BEventSeaMap(const QDateTime& dt, const BCoordinates& newOrigin)
  throw() :BEvent("", dt), _origin(newOrigin) {
  setEventFlags(SystemEventFlag);
}

/** \brief 
*/
BEventSeaMap::~BEventSeaMap(){
}

void BEventSeaMap::exec() {
  BCoordinates oldC = bApp->battle()->seaMap()->originalCoordinates();
  if (_origin == oldC)
    return;
  bApp->battle()->seaMap()->setOriginalCoordinates(_origin);
}

void BEventSeaMap::parse(const QDomElement& /* element */, Battle* /* battle */) 
  {
  throw BInternalException(__FILE__, __LINE__,
    "BEventSeaMap can not be saved in XML");
}

QDomElement BEventSeaMap::toXml(QDomDocument& doc) const {
  throw BInternalException(__FILE__, __LINE__,
    "BEventSeaMap can not be saved in XML");
  QDomElement e = BEvent::toXml(doc);
  return e;
}

QString BEventSeaMap::description() const {
  return qApp->translate("BEventSeaMap", "Change map size");
}
