/******************************************************************************/
/* BEventsHandler -     (impl.)            */
/******************************************************************************/
static const char beventshandler_cpp_id[]="@(#) $Id: beventshandler.cpp,v 1.2 2004/10/10 10:18:20 Oleksiy Balabay Exp $"; static const char* beventshandler_cpp_id_id=beventshandler_cpp_id;

#include "beventshandler.h"
#include "beventsparser.h"

/** \file beventshandler.cpp
  \brief  BEventsHandler   (impl.)

     BEventsHandler  
*/

/** \class BEventsHandler
  \brief 


*/
/** \brief 
*/
BEventsHandler::BEventsHandler(BEventsParser* parent):BDomHandler(0, false),
  _parent(parent) {
  isDomMode = false;
}

/** \brief 
*/
BEventsHandler::~BEventsHandler(){
  delete doc;
}

bool BEventsHandler::startElement( const QString&, const QString&, const QString& qName, const QXmlAttributes& atts )
{
  if (qName == BEventsParser::SOM_DATE) {
    if (isDomMode)
      return false;
    else {
      isDomMode = true;
      doc = new QDomDocument();
      node = *doc;
    }
  }
  if (isDomMode)
    return BDomHandler::startElement("","",qName,atts);
  else {
    if (qName != BEventsParser::SOM_EVENTS)
      qWarning("Unsupported tag: %s", (const char*)qName.local8Bit());
    return true;
  }
}

bool BEventsHandler::endElement( const QString&, const QString&, const QString& qName )
{
  if (isDomMode) {
    if (qName == BEventsParser::SOM_DATE) {
      // TODO:     
      try {
        _parent->parseDate(doc->documentElement());
      }
      catch(...) {
        delete doc;
        doc = 0;
        throw;
      }
      delete doc;
      doc = 0;
      isDomMode = false;
      return TRUE;
    }
    else {
      return BDomHandler::endElement("","",qName);
    }
  }
  else
    return true;
}

bool BEventsHandler::characters( const QString&  ch )
{
  if (!isDomMode)
    return TRUE;
  else
    return BDomHandler::characters(ch);
}

bool BEventsHandler::processingInstruction( const QString& target, const QString& data )
{
  if (!isDomMode)
    return TRUE;
  else
    return BDomHandler::processingInstruction(target, data);
}

bool BEventsHandler::skippedEntity( const QString& name )
{
  if (!isDomMode)
    return TRUE;
  else
    return BDomHandler::skippedEntity(name);
}

bool BEventsHandler::comment( const QString& ch )
{
  if (!isDomMode)
    return TRUE;
  else
    return BDomHandler::comment(ch);
}

