/******************************************************************************/
/* BEventsListView -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char beventslistview_cpp_id[]="@(#) $Id: beventslistview.cpp,v 1.3 2005/01/16 15:33:39 Oleksiy Balabay Exp $"; static const char* beventslistview_cpp_id_id=beventslistview_cpp_id;

#include <qpixmap.h>

#include "beventslistview.h"
#include "bevent.h"
#include "bapplication.h"
#include "battle.h"
#include "bevent.h"
#include "xpms/ask.xpm"
#include "xpms/execute.xpm"

/** \file beventslistview.cpp
  \brief  BEventsListView  BattleFleet (impl.)

     BEventsListView  BattleFleet
*/

/** \class BEventsListView
  \brief 


*/
/** \brief 
*/
BEventsListView::BEventsListView(QWidget* parent, const char* name)
:QListView(parent, name) {
  addColumn(tr("Action"), 18);
  addColumn(tr("Date"));
  addColumn(tr("Object"), 50);
  addColumn(tr("Description"), 100);
//  BEvents::BEventList* evs = &(bApp->battle()->_events->_events);
//  typedef BEvents::BEventList::iterator BELI;
//  for (BELI it = evs->begin(); it != evs->end(); it++) {
//    new BEventsListViewItem(this, (*it));
//  }
  setSorting(-1);
  updateEventsList();
//  setMinimumWidth(100);
//  QSizePolicy sp = sizePolicy();
//  sp.setHorData(QSizePolicy::Minimum);
//  setSizePolicy(sp);
  setHScrollBarMode(AlwaysOn);
  setSelectionMode(Extended);
  setAllColumnsShowFocus(true);
}

/** \brief 
*/
BEventsListView::~BEventsListView(){

}

QPixmap* BEventsListViewItem::_executeXpm = 0;
QPixmap* BEventsListViewItem::_askXpm = 0;

BEventsListViewItem::BEventsListViewItem( QListView *parent, BEvent* ev )
:QListViewItem(parent), _event(ev) {
  setColumns(ev);
}

BEventsListViewItem::BEventsListViewItem( QListViewItem *parent, BEvent* ev )
:QListViewItem(parent), _event(ev) {
  setColumns(ev);
}

BEventsListViewItem::BEventsListViewItem( QListView *parent, 
  QListViewItem *after, BEvent* ev ):QListViewItem(parent, after), _event(ev) {
  setColumns(ev);
}

void BEventsListViewItem::setColumns(BEvent* ev) {
  if (!_executeXpm) {
    _executeXpm = new QPixmap(execute_xpm);
  }
  if (!_askXpm) {
    _askXpm = new QPixmap(ask_xpm);
  }
//  setPixmap(ActionCol, *_executeXpm);
  setText(DateCol, ev->date().toString());
  setText(ObjectCol, ev->objectName());
  setText(DescrCol, ev->description());
}

BEventsListViewItem::~BEventsListViewItem() {
}

void BEventsListView::setAskOnSelection() {
  QListViewItemIterator lit(this, QListViewItemIterator::Selected);
  while (lit.current()) {
    BEventsListViewItem* i = (BEventsListViewItem*)(lit.current());
    i->setAsk();
    lit++;
  }
}

void BEventsListView::setExecuteOnSelection() {
  QListViewItemIterator lit(this, QListViewItemIterator::Selected);
  while (lit.current()) {
    BEventsListViewItem* i = (BEventsListViewItem*)(lit.current());
    i->setExecute();
    lit++;
  }
}

void BEventsListView::setRemoveOnSelection() {
  ;
}

void BEventsListView::updateEventsList() {
  BEvents::BEventList* evs = &(bApp->battle()->_events->_events);
  typedef BEvents::BEventList::iterator BELI;
  QListViewItemIterator lit(this);
  // debug
  //for (BELI it = evs->begin(); it != evs->end(); it++) {
  //  qDebug("EV: %s - %s", 
  //    (const char*)(*it)->date().toString().local8Bit(),
  //    (const char*)(*it)->objectName().local8Bit());
  //}
  //  2  
  for (BELI it = evs->begin(); it != evs->end(); it++) {
    BEventsListViewItem* i;
    if (lit.current())
      i = (BEventsListViewItem*)(lit.current());
    else {
      new BEventsListViewItem(this, lastItem(), (*it));
      continue;
    }
    //   ,     
    //   
//    BEvent* debug = (*it);
    if ( i->event() == (*it)) {
      lit++;
    }
    //       ,     
    else {
      bool exists = false;
      QListViewItemIterator lit1 = lit;
      while (lit1.current()) {
        BEventsListViewItem* j = (BEventsListViewItem*)(lit1.current());
        if (j->event() == (*it)) {
          exists = true;
          break;
        }
        lit1++;
      }
      if (exists) {
        //        
        //  
        while ( ((BEventsListViewItem*)(lit.current()))->event() != (*it)) {
          QListViewItem* item = lit.current();
          lit++;
          takeItem(item);
          delete item;
        } 
        //       
        lit++;
      }
      else {
        new BEventsListViewItem(this, lit.current(), (*it));
        lit++;
        ASSERT((*it) == ((BEventsListViewItem*)(lit.current()))->event());
      }
    }
  }
  while ( lit.current() ) {
    QListViewItem* item = lit.current();
    lit++;
    takeItem(item);
    delete item;
  }          
}

void BEventsListViewItem::setAsk() {
  setPixmap(ActionCol, *_askXpm);
  unsigned int evFlag = _event->eventFlags();
  evFlag = evFlag | BEvent::AskBeforeExecuteEventFlag;
  _event->setEventFlags(evFlag);
}

void BEventsListViewItem::setExecute() {
  setPixmap(ActionCol, QPixmap());
  unsigned int evFlag = _event->eventFlags();
  evFlag = evFlag & (~BEvent::AskBeforeExecuteEventFlag);
  _event->setEventFlags(evFlag);
}
