/******************************************************************************/
/* BEventsListView -   BattleFleet              */
/******************************************************************************/

#ifndef BEventsListView_H
#define BEventsListView_H
static const char beventslistview_h_id[]="@(#) $Id: beventslistview.h,v 1.1 2004/08/08 15:20:37 Oleksiy Balabay Exp $"; static const char* beventslistview_h_id_id=beventslistview_h_id;
/** \file beventslistview.h
  \brief  BEventsListView  BattleFleet

     BEventsListView  BattleFleet
*/
#include <qlistview.h>

class BEvent;

class BEventsListView: public QListView {
  Q_OBJECT
public:
  BEventsListView(QWidget* parent, const char* name);
  virtual ~BEventsListView();
public slots:
  void setAskOnSelection();
  void setExecuteOnSelection();
  void setRemoveOnSelection();
public:
  void updateEventsList();
};

class BEventsListViewItem: public QListViewItem {
public:
  BEventsListViewItem( QListView *parent, BEvent* ev );
  BEventsListViewItem( QListViewItem *parent, BEvent* ev );
  BEventsListViewItem( QListView *parent, QListViewItem *after, BEvent* ev );
  virtual ~BEventsListViewItem();
  BEvent* event() const {
    return _event;
  }
  void setAsk();
  void setExecute();
private:
  enum Columns {
    ActionCol = 0,
    DateCol = 1,
    ObjectCol = 2,
    DescrCol = 3
  };
private:
  void setColumns(BEvent* ev);
private:
  BEvent* _event;
  static QPixmap* _executeXpm;
  static QPixmap* _askXpm;
};

#endif // BEventsListView_H
