/******************************************************************************/
/* BEventsParser -   BattleFleet              */
/******************************************************************************/

#ifndef BEventsParser_H
#define BEventsParser_H
static const char beventsparser_h_id[]="@(#) $Id: beventsparser.h,v 1.7 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* beventsparser_h_id_id=beventsparser_h_id;
/** \file beventsparser.h
  \brief  BEventsParser  BattleFleet

     BEventsParser  BattleFleet
*/
#include <qstring.h>
#include <qdatetime.h>

class Battle;
class BEventsHandler;
class QDomElement;

class BEventsParser {
  friend class BEventsHandler;
public:
  BEventsParser(const QString& fileName, Battle* battle);
  virtual ~BEventsParser();
  void parse(); 
public:
  static const QString SOM_DATE;
  static const QString SOM_OBJECT;
  static const QString SOM_NAME;
  static const QString SOM_EVENTS;
protected:
  void parseDate(const QDomElement& element);
  void parseObject(const QDomElement& element);
  void parseEvent(const QDomElement& element, const QString& objectName);
protected:
  Battle* _battle;
  QDateTime _date;
  BEventsHandler* _eventsHandler;
  QString _fileName;
  QString _origFileName;
private:
  ///  
  static const unsigned int PROGRESS_LOW;
  static const unsigned int PROGRESS_HIGH;
  static const unsigned int AVERAGE_EVENT_SIZE;
  unsigned int _eventsProcessed;
  unsigned int _eventsPer1Progress;
};

#endif // BEventsParser_H
