/******************************************************************************/
/* BEventState -   BattleFleet              */
/******************************************************************************/

#ifndef BEventState_H
#define BEventState_H
static const char beventstate_h_id[]="@(#) $Id: beventstate.h,v 1.4 2004/08/08 15:20:37 Oleksiy Balabay Exp $"; static const char* beventstate_h_id_id=beventstate_h_id;
/** \file beventstate.h
  \brief  BEventState  BattleFleet

     BEventState  BattleFleet
*/

#include "bevent.h"

class BattleObject;
class BProgram;

class BEventState: public BEvent {
public:
  BEventState(const QString& objectName, 
    const QDateTime& dt = QDateTime()) throw();
  virtual ~BEventState();
  virtual void exec();
  virtual void parse(const QDomElement& element, Battle* battle); 
  virtual QDomElement toXml(QDomDocument& doc) const;
  virtual QString description() const;
public:
  static const QString BE_EVENT_TYPE_STATE;
private:
  QDomElement _el;
};

class BEventSide: public BEvent {
public:
  BEventSide(const QString& objectName, 
    const QDateTime& dt = QDateTime()) throw();
  BEventSide(const QString& objectName, int side, 
    const QDateTime& dt = QDateTime());
  virtual ~BEventSide();
  virtual void exec();
  virtual void parse(const QDomElement& element, Battle* battle); 
  virtual QDomElement toXml(QDomDocument& doc) const;
  virtual QString description() const;
public:
  static const QString BE_EVENT_TYPE_SIDE;
  static const QString SIDE;
private:
  int _side;
};

#endif // BEventState_H
