/******************************************************************************/
/* BEventsView -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char beventsview_cpp_id[]="@(#) $Id: beventsview.cpp,v 1.2 2005/01/05 11:47:23 Oleksiy Balabay Exp $"; static const char* beventsview_cpp_id_id=beventsview_cpp_id;

#include "beventsview.h"
#include "battle.h"

/** \file beventsview.cpp
  \brief  BEventsView  BattleFleet (impl.)

     BEventsView  BattleFleet
*/

#include <qlayout.h>
#include <qtoolbutton.h>

#include "xpms/ask.xpm"
#include "xpms/execute.xpm"
#include "xpms/remove.xpm"

#include "beventslistview.h"

/** \class BEventsView
  \brief 


*/
/** \brief 
*/
BEventsView::BEventsView(QWidget* parent, const char* name):
QDockWindow(parent, name){
  _view = new QWidget(this, "eventsviewcentral");
  setWidget(_view);
  setCloseMode(Always);
  setMovingEnabled(true);
  setResizeEnabled(true);
  setCaption(tr("Events"));
  
  QHBoxLayout* topLayout = new QHBoxLayout;
  topLayout->setSpacing(0);
  _executeButton = new QToolButton(_view, "executebutton");
  _executeButton->setIconSet(QIconSet(execute_xpm));
  _executeButton->setTextLabel(tr("Execute"), true);
  topLayout->addWidget(_executeButton);

  _askButton = new QToolButton(_view, "askbutton");
  _askButton->setIconSet(QIconSet(ask_xpm));
  _askButton->setTextLabel(tr("Ask"), true);
  topLayout->addWidget(_askButton);

  _removeButton = new QToolButton(_view, "removebutton");
  _removeButton->setIconSet(QIconSet(remove_xpm));
  _removeButton->setTextLabel(tr("Remove"), true);

  topLayout->addWidget(_removeButton);

  topLayout->addStretch(10);

  QVBoxLayout* mainLayout = new QVBoxLayout(_view);
  mainLayout->addLayout(topLayout);

  _list = new BEventsListView(_view, "eventslistview");
  connect(_executeButton, SIGNAL(clicked()),
    _list, SLOT(setExecuteOnSelection()));
  connect(_askButton, SIGNAL(clicked()),
    _list, SLOT(setAskOnSelection()));
  connect(_removeButton, SIGNAL(clicked()),
    _list, SLOT(setRemoveOnSelection()));
  mainLayout->addWidget(_list);
  _view->show();
}

/** \brief 
*/
BEventsView::~BEventsView(){

}

void BEventsView::updateView(const BattleInfo& bi) {
  if ( (bi.flags & BFEvent) != 0) {
    _list->updateEventsList();
  }
}

BEventsViewPlay::BEventsViewPlay(QWidget* parent, const char* name)
:BEventsView(parent, name){
  _askButton->hide();
  _executeButton->hide();
  _removeButton->hide();
}

BEventsViewPlay::~BEventsViewPlay(){

}
