/******************************************************************************/
/* BFactory -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bfactory_cpp_id[]="@(#) $Id: bfactory.cpp,v 1.12 2005/02/20 14:44:58 Oleksiy Balabay Exp $"; static const char* bfactory_cpp_id_id=bfactory_cpp_id;

#include "bfactory.h"
#include "bappstate.h"
#include "bappstateedit.h"
#include "bappstategame.h"
#include "bapplication.h"
#include "bmainwindowstateundefined.h"
#include "bmainwindowstateedit.h"
#include "bmainwindowstateplay.h"
#include "bmainwindowstategame.h"
#include "bobservercentraledit.h"
#include "bobservercentralplay.h"
#include "bobservercentralgame.h"
#include "bpvstate.h"
#include "bgroupview.h"
#include "beventsview.h"
#include "bai.h"

/** \file bfactory.cpp
  \brief  BFactory  BattleFleet (impl.)

     BFactory  BattleFleet
*/

/** \class BFactory
  \brief 


*/
/** \brief 
*/
BFactory::BFactory(){
}

/** \brief 
*/
BFactory::~BFactory(){
}

BPVStateSeaMap* BFactory::createPVStateSeaMap(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateSeaMap(view, observer);
}

BPVStateShip* BFactory::createPVStateShip(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShip(view, observer);
}

BPVStateShipGroup* BFactory::createPVStateShipGroup(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShipGroup(view, observer);
}

BGroupView* BFactory::createGroupView(BUiState* uiState, QWidget* parent) {
  BGroupView* gv = new BGroupView(uiState, parent, "group_view");
  gv->init();
  return gv;
}

BEventsView* BFactory::createEventsView(QWidget* parent) {
  return new BEventsView(parent, "eventsview");
}

BAIs* BFactory::createAIs(Battle* battle, QObject* parent) {
  BAIs* ais = new BAIs(battle, parent, "ais");
  return ais;
}

BFactoryUndefined::BFactoryUndefined(){
}

BFactoryUndefined::~BFactoryUndefined(){
}

BAppState* BFactoryUndefined::createAppState() 
 {
  return new BAppStateUndefined();
}

BMainWindowState* BFactoryUndefined::createMainWindowState(Battle* battle,
  BMainWindow* mainWindow) {
  BMainWindowState * mainWindowState = 
    new BMainWindowStateUndefined(battle, mainWindow, 
    "mainWindowStateUndefined");
  mainWindowState->init();
  return mainWindowState;
}

BattleObserver* BFactoryUndefined::createCentral(BUiState* /* uiState */, 
  Battle* /* battle */, 
  const BPlayer* /* player */) {
  return new BattleObserver(0,0,"");
}

BFactoryPlay::BFactoryPlay(){
}

BFactoryPlay::~BFactoryPlay(){
}

BAppState* BFactoryPlay::createAppState()
 {
  BAppState* appState = new BAppStatePlay();
  return appState;
}

BMainWindowState* BFactoryPlay::createMainWindowState(Battle* battle,
  BMainWindow* mainWindow) {
  BMainWindowState * mainWindowState = 
    new BMainWindowStatePlay(battle, mainWindow, "mainWindowStatePlay");
  mainWindowState->init();
  return mainWindowState;
}

BattleObserver* BFactoryPlay::createCentral(BUiState* uiState, Battle* battle, 
  const BPlayer* /* player */) {
  BattleObserver* bo = new BObserverCentralPlay(uiState, battle,0,"");
  bo->init();
  return bo;
}

BGroupView* BFactoryPlay::createGroupView(BUiState* uiState, QWidget* parent) {
  BGroupViewPlay* gv = new BGroupViewPlay(uiState, parent, "group_view_play");
  gv->init();
  return gv;
}

BEventsView* BFactoryPlay::createEventsView(QWidget* parent) {
  return new BEventsViewPlay(parent, "eventsview");
}

BPVStateSeaMap* BFactoryPlay::createPVStateSeaMap(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateSeaMapPlay(view, observer);
}

BPVStateShip* BFactoryPlay::createPVStateShip(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShipPlay(view, observer);
}

BPVStateShipGroup* BFactoryPlay::createPVStateShipGroup(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShipGroupPlay(view, observer);
}

BFactoryEdit::BFactoryEdit(){
}

BFactoryEdit::~BFactoryEdit(){
}

BAppState* BFactoryEdit::createAppState()
 {
  BAppState* appState = new BAppStateEdit();
  return appState;
}

BMainWindowState* BFactoryEdit::createMainWindowState(Battle* battle,
  BMainWindow* mainWindow) {
  BMainWindowState * mainWindowState = 
    new BMainWindowStateEdit(battle, mainWindow, "mainWindowStateEdit");
  mainWindowState->init();
  return mainWindowState;
}

BattleObserver* BFactoryEdit::createCentral(BUiState* uiState, Battle* battle, 
  const BPlayer* /* player */) {
  BattleObserver* bo =  new BObserverCentralEdit(uiState, battle,0,"");
  bo->init();
  return bo;
}

BPVStateSeaMap* BFactoryEdit::createPVStateSeaMap(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateSeaMapEdit(view, observer);
}

BPVStateShip* BFactoryEdit::createPVStateShip(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShipEdit(view, observer);
}

BPVStateShipGroup* BFactoryEdit::createPVStateShipGroup(PropertyList* view, 
  BattleObserver* observer) {
  return new BPVStateShipGroupEdit(view, observer);
}

BAIs* BFactoryEdit::createAIs(Battle* battle, QObject* parent) {
  BAIs* ais = new BAIsEdit(battle, parent, "ais");
  return ais;
}


BFactoryGame::BFactoryGame(){
}

BFactoryGame::~BFactoryGame(){
}

BAppState* BFactoryGame::createAppState()
 {
  BAppState* appState = new BAppStateGame();
  return appState;
}

BMainWindowState* BFactoryGame::createMainWindowState(Battle* battle,
  BMainWindow* mainWindow) {
  BMainWindowState * mainWindowState = 
    new BMainWindowStateGame(battle, mainWindow, "mainWindowStateEdit");
  mainWindowState->init();
  return mainWindowState;
}

BattleObserver* BFactoryGame::createCentral(BUiState* uiState, Battle* battle, 
  const BPlayer* /* player */) {
  BattleObserver* bo =  new BObserverCentralGame(uiState, battle,0,"");
  bo->init();
  return bo;
}
