/******************************************************************************/
/* BFactory -   BattleFleet              */
/******************************************************************************/

#ifndef BFactory_H
#define BFactory_H
static const char bfactory_h_id[]="@(#) $Id: bfactory.h,v 1.9 2005/02/20 14:44:58 Oleksiy Balabay Exp $"; static const char* bfactory_h_id_id=bfactory_h_id;
/** \file bfactory.h
  \brief  BFactory  BattleFleet

     BFactory  BattleFleet
*/
#include <qstring.h>

class BAppState;
class BMainWindow;
class BMainWindowState;
class BException;
struct BPlayer;
class BattleObserver;
class Battle;
class BUiState;
class BApplication;
struct BLoadData;
class PropertyList;
class BPVStateSeaMap;
class BPVStateShip;
class BPVStateShipGroup;
class BGroupView;
class QWidget;
class BEventsView;
class BAIs;
class QObject;


class BFactory {
  friend class BApplication;
protected:
  BFactory();
public:
  virtual ~BFactory();
  virtual BAppState* createAppState() = 0;
  virtual BMainWindowState* createMainWindowState(Battle* battle, 
    BMainWindow* mainWindow) = 0;
  virtual BattleObserver* createCentral(BUiState* uiState, Battle* battle,
    const BPlayer* player) = 0;
  virtual BPVStateSeaMap* createPVStateSeaMap(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShip* createPVStateShip(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShipGroup* createPVStateShipGroup(PropertyList* view, 
    BattleObserver* observer);
  virtual BGroupView* createGroupView(BUiState* uiState, QWidget* parent);
  virtual BEventsView* createEventsView(QWidget* parent);
  virtual BAIs* createAIs(Battle* battle, QObject* parent);
//  virtual createSmall(const BPlayer* player);
};

class BFactoryUndefined: public BFactory {
  friend class BApplication;
protected:
  BFactoryUndefined();
public:
  virtual ~BFactoryUndefined();
  virtual BAppState* createAppState();
  virtual BMainWindowState* createMainWindowState(Battle* battle,
    BMainWindow* mainWindow);
  virtual BattleObserver* createCentral(BUiState* uiState, Battle* battle, 
    const BPlayer* player);
};

class BFactoryPlay: public BFactory {
  friend class BApplication;
protected:
  BFactoryPlay();
public:
  virtual ~BFactoryPlay();
  virtual BAppState* createAppState();
  virtual BMainWindowState* createMainWindowState(Battle* battle,
    BMainWindow* mainWindow);
  virtual BattleObserver* createCentral(BUiState* uiState, Battle* battle, 
    const BPlayer* player);
  virtual BGroupView* createGroupView(BUiState* uiState, QWidget* parent);
  virtual BEventsView* createEventsView(QWidget* parent);
  virtual BPVStateSeaMap* createPVStateSeaMap(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShip* createPVStateShip(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShipGroup* createPVStateShipGroup(PropertyList* view, 
    BattleObserver* observer);
};

class BFactoryEdit: public BFactory {
  friend class BApplication;
protected:
  BFactoryEdit();
public:
  virtual ~BFactoryEdit();
  virtual BAppState* createAppState();
  virtual BMainWindowState* createMainWindowState(Battle* battle,
    BMainWindow* mainWindow);
  virtual BattleObserver* createCentral(BUiState* uiState, Battle* battle, 
    const BPlayer* player);
  virtual BPVStateSeaMap* createPVStateSeaMap(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShip* createPVStateShip(PropertyList* view, 
    BattleObserver* observer);
  virtual BPVStateShipGroup* createPVStateShipGroup(PropertyList* view, 
    BattleObserver* observer);
  virtual BAIs* createAIs(Battle* battle, QObject* parent);
};

class BFactoryGame: public BFactory {
  friend class BApplication;
protected:
  BFactoryGame();
public:
  virtual ~BFactoryGame();
  virtual BAppState* createAppState();
  virtual BMainWindowState* createMainWindowState(Battle* battle,
    BMainWindow* mainWindow);
  virtual BattleObserver* createCentral(BUiState* uiState, Battle* battle, 
    const BPlayer* player);
};

#endif // BFactory_H
