/******************************************************************************/
/* BFConfig -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bfconfig_cpp_id[]="@(#) $Id: bfconfig.cpp,v 1.1 2004/10/01 02:41:31 Oleksiy Balabay Exp $"; static const char* bfconfig_cpp_id_id=bfconfig_cpp_id;

#include "bfconfig.h"

/** \file bfconfig.cpp
  \brief  BFConfig  BattleFleet (impl.)

     BFConfig  BattleFleet
*/

/** \class BFConfig
  \brief 


*/
const QString BFConfig::BF_CONFIG = "BFConfig";

/** \brief 
*/
BFConfig::BFConfig(const QString& fileName):BXmlConfig(fileName) {
  if (_doc->documentElement().tagName() != BF_CONFIG) {
    throw BConfigException(__FILE__, __LINE__, qApp->translate("BFConfig",
      "'%1' document expected, '%2' found").arg(BF_CONFIG).arg(
      _doc->documentElement().tagName()));
  }
}

/** \brief 
*/
BFConfig::~BFConfig(){

}

QString BFConfig::element(const QString& name, const QString& defValue ) const {
  QDomElement docElem = _doc->documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
    QDomElement e = n.toElement();
    n = n.nextSibling();
    if( !e.isNull() ) {
      if (e.tagName() == name) 
        return e.text();
    }
  }
  return defValue;
}

QString BFConfig::subElement(const QString& parent, const QString& name, 
  const QString& defValue) const {
  QDomElement docElem = _doc->documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
    QDomElement e = n.toElement();
    n = n.nextSibling();
    if( !e.isNull() ) { 
      if (e.tagName() == parent) { 
        QDomNode n1 = e.firstChild();
        while (!n1.isNull()) {
          QDomElement e1 = n1.toElement();
          n1 = n1.nextSibling();
          if (!e1.isNull()) {
            if (e1.tagName() == name)
              return e1.text();
          }
        }
      }
    }
  }
  return defValue;
}

QString BFConfig::attribute(const QString& elementName,
  const QString& attributeName, const QString& defValue) const {
  QDomElement docElem = _doc->documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
    QDomElement e = n.toElement();
    n = n.nextSibling();
    if( !e.isNull() ) {
      if (e.tagName() == elementName) 
        return e.attribute(attributeName, defValue);
    }
  }
  return defValue;
}

QString BFConfig::attribute(const QString& parentElementName, const QString& elementName,
  const QString& attributeName, const QString& defValue) const {
  QDomElement docElem = _doc->documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
    QDomElement e = n.toElement();
    n = n.nextSibling();
    if( !e.isNull() ) { 
      if (e.tagName() == parentElementName) { 
        QDomNode n1 = e.firstChild();
        while (!n1.isNull()) {
          QDomElement e1 = n1.toElement();
          n1 = n1.nextSibling();
          if (!e1.isNull()) {
            if (e1.tagName() == elementName)
              return e1.attribute(attributeName, defValue);
          }
        }
      }
    }
  }
  return defValue;
}

QDomElement BFConfig::domElement(const QString& name) {
  QDomElement docElem = _doc->documentElement();
  QDomNode n = docElem.firstChild();
  while( !n.isNull() ) {
    QDomElement e = n.toElement();
    n = n.nextSibling();
    if( !e.isNull() ) {
      if (e.tagName() == name) 
        return e;
    }
  }
  return _doc->createElement(name);
}
