/******************************************************************************/
/* BLog -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char blog_cpp_id[]="@(#) $Id: blog.cpp,v 1.9 2005/02/20 14:44:58 Oleksiy Balabay Exp $"; static const char* blog_cpp_id_id=blog_cpp_id;

#include <qwhatsthis.h>
#include <qapplication.h>
#include <qpopupmenu.h>

#include "blog.h"
#include "bmainwindow.h"

/** \file blog.cpp
  \brief  BLog  BattleFleet (impl.)

     BLog  BattleFleet
*/

/** \class BLog
  \brief 


*/
const char* B_LOG = QT_TRANSLATE_NOOP("BLog", "Log");

/** \brief 
*/
BLog::BLog(QWidget* parent, const char* name):QDockWindow(parent, name) {
  QWhatsThis::add(this, tr(
    "<b>%1</b><br><br>"
    "General message window. This window is used to inform "
    "player about non-standard situations "
    "and main scenario events").arg(tr(B_LOG))
  );
  _logText = new BLogText(this, "logtext");
  _logText->setTextFormat(Qt::LogText);
  _logText->setMaxLogLines(100);
  setWidget(_logText);
  _logText->show();
  setCloseMode(Always);
  setResizeEnabled(true);
  setMovingEnabled(true);
  setCaption(tr(B_LOG));
  setFocusPolicy(NoFocus);
  _logText->setFocusPolicy(NoFocus);
}

/** \brief 
*/
BLog::~BLog(){
}

void BLog::logText(const QString& message) {
  QString m = message;
  m = m.replace("&","#!#");
  m.replace("<","&lt;");
  m.replace(">","&gt;");
  m.replace("#!#","&amp;");
  _logText->append(m);
  _logText->scrollToBottom();
}

void BLog::clear() {
  _logText->clear();
}

BLogText::BLogText(QWidget* parent, const char* name)
:QTextEdit(parent, name) {
}

BLogText::~BLogText() {
}

void BLogText::contentsMousePressEvent(QMouseEvent* e) {
  qApp->postEvent(qApp->activeWindow(), new BFocusEvent());
}

QPopupMenu* BLogText::createPopupMenu(const QPoint& pos) {
  QPopupMenu* p = QTextEdit::createPopupMenu(pos);
  p->insertItem(tr("Crear all"), this, SLOT(clear()));
  return p;
}