/******************************************************************************/
/* BMainWindow -   BattleFleet              */
/******************************************************************************/

#ifndef BMainWindow_H
#define BMainWindow_H
static const char bmainwindow_h_id[]="@(#) $Id: bmainwindow.h,v 1.14 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* bmainwindow_h_id_id=bmainwindow_h_id;
/** \file bmainwindow.h
  \brief  BMainWindow  BattleFleet

     BMainWindow  BattleFleet
*/
//#include "bmainwindowbase.h"
#include <qmainwindow.h>
#include <qevent.h>

#include "bcustomeventconsts.h"
#include "bapplication.h"

class BMainWindowState;
class BLog;

class BFocusEvent: public QCustomEvent {
public:
  BFocusEvent():QCustomEvent(BFocusEventNumber){
  }
};

class BMainWindow: public QMainWindow {
  Q_OBJECT
public:
  BMainWindow();
  virtual ~BMainWindow();
  static const QString S_MAIN_WINDOW;
  BLog* logDockWindow() const;
public slots:
  void slotModeChanged(const BAppModes newMode, const BAppModes oldMode);
  void slotLog(const QString& message);
  void slotSaveSettings();
protected:
  virtual void closeEvent(QCloseEvent* e);
  virtual void mousePressEvent(QMouseEvent* e);
  virtual void customEvent(QCustomEvent* e);
private:
  void loadWindowPosSize();
  void saveWindowPosSize();
private:
  BMainWindowState* _state;
  BLog* _log;
signals:
  void newScenario();
  void log(const QString& message);
};

#endif // BMainWindow_H
