/******************************************************************************/
/* BMainWindowStateEdit -   BattleFleet              */
/******************************************************************************/

#ifndef BMainWindowStateEdit_H
#define BMainWindowStateEdit_H
static const char bmainwindowstateedit_h_id[]="@(#) $Id: bmainwindowstateedit.h,v 1.10 2004/10/13 05:33:51 Oleksiy Balabay Exp $"; static const char* bmainwindowstateedit_h_id_id=bmainwindowstateedit_h_id;
/** \file bmainwindowstateedit.h
  \brief  BMainWindowStateEdit  BattleFleet

     BMainWindowStateEdit  BattleFleet
*/
#include "bmainwindowstate.h"

class BShipsDbView;
class BattleObject;

class BMainWindowStateEdit: public BMainWindowState {
  Q_OBJECT
public:
  BMainWindowStateEdit(Battle* battle, BMainWindow* mainWindow, 
    const char* name);
  virtual ~BMainWindowStateEdit();
  virtual void init();
  virtual bool wantToQuitBattle();
  virtual void update();
public slots:
  virtual void slotBattleInfoChanged(const BattleInfo& info);
protected:
  virtual void initFileGroup();
  virtual QString defaultSettingsString() const;
protected:
  QAction* fileSaveAction;
  QAction* fileSaveAsAction;
  QAction* fileLoadShipsAction;
  QAction* fileUnloadShipsAction;
  QAction* filePropertiesAction;
protected slots:
  virtual void fileSave();
  virtual void fileSaveAs();
  virtual void fileLoadShips();
  virtual void fileProperties();
protected:
  virtual QString stateName() const;
  virtual void initBase();
  // init ships db view
  virtual void initShipsDbView();
  BShipsDbView* _shipsDbView;
  // central group
  virtual void initCentralGroup();
  // ships group
protected:
  virtual void initShipsGroup();
protected:
  QAction* shipsOrderAction;
protected slots:
  virtual void shipsOrder();
//  virtual void shipsUngroup();
};

#endif // BMainWindowStateEdit_H
