/******************************************************************************/
/* BMainWindowStateGame -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bmainwindowstategame_cpp_id[]="@(#) $Id: bmainwindowstategame.cpp,v 1.15 2005/03/07 15:34:37 Oleksiy Balabay Exp $"; static const char* bmainwindowstategame_cpp_id_id=bmainwindowstategame_cpp_id;

/** \file bmainwindowstategame.cpp
  \brief  BMainWindowStateGame  BattleFleet (impl.)

     BMainWindowStateGame  BattleFleet
*/

#include <qcombobox.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>
#include <qstatusbar.h>
#include <qfileinfo.h>
#include <qdir.h>
#include <qprogressdialog.h>
#include <qfile.h>
#include <qtextstream.h>

#include "bmainwindowstategame.h"
#include "bapplication.h"
#include "bmainwindow.h"
#include "bfactory.h"
#include "battle.h"
#include "bpropertyview.h"
#include "bgroupview.h"
#include "bscenariosave.h"
#include "bscenarioheader.h"
#include "bcontrolmoveview.h"
#include "buistate.h"
#include "beventsview.h"
#include "blog.h"
#include "bmainwindowtexts.h"
#include "bai.h"

/** \class BMainWindowStateGame
  \brief 


*/
/** \brief 
*/
BMainWindowStateGame::BMainWindowStateGame(Battle* battle, 
  BMainWindow* mainWindow, const char* name):BMainWindowState(battle, 
  mainWindow, name) {
  _central = 0;
  _mainWindow->setCaption(tr("%1. Game Mode - BattleFleet").arg(
    battle->scenarioHeader()->name()));
//  _mainWindow->menuBar()->hide();
}

QString BMainWindowStateGame::defaultSettingsString() const {
  //    ,     
  QString s = 
"\n"
"\n"
"\n"+
fileToolBar->caption()+","+
battleToolBar->caption()+","+
viewToolBar->caption()+","+
shipsToolBar->caption()+","+
aiToolBar->caption()+","+
helpToolBar->caption()+",\n"+
"["+fileToolBar->caption()+",0,1,-1,-1,1]["+
battleToolBar->caption()+",0,0,-1,-1,1]["+
viewToolBar->caption()+",0,0,-1,-1,1]["+
shipsToolBar->caption()+",0,0,-1,-1,1]["+
aiToolBar->caption()+",0,0,-1,-1,1]["
+helpToolBar->caption()+",0,0,-1,-1,1]\n"+
_mainWindow->logDockWindow()->caption()+","+
_controlMoveView->caption()+",\n"
"["+_mainWindow->logDockWindow()->caption()+",0,1,-1,141,1]["+
_controlMoveView->caption()+",562,0,-1,-1,1]\n"
+_groupView->caption()+","+
_propertyView->caption()+",\n"
"["+_groupView->caption()+",96,1,174,-1,1]["+
_propertyView->caption()+",0,0,174,-1,1]\n"
"\n"
"\n";
  return s;
}

/** \brief 
*/
BMainWindowStateGame::~BMainWindowStateGame() {
  saveSettings();
  if (_central) {
    delete _central;
  }
  clear();
}

void BMainWindowStateGame::slotBattleInfoChanged(const BattleInfo& info) {
//  _timeLabel->setText(info.modelTime.toString());
  _propertyView->updateView();
  _groupView->updateView(info);
//  _eventsView->updateView(info);
  update();
}

QString BMainWindowStateGame::stateName() const {
  return "Game";
}

void BMainWindowStateGame::initBase() {
  initFileGroup();
//  bApp->checkProgressDialog(81);
  initBattleGroup();
//  bApp->checkProgressDialog(82);
  initViewGroup();
//  bApp->checkProgressDialog(83);
  initToolsGroup();
//  bApp->checkProgressDialog(84);
  initShipsGroup();
  bApp->checkProgressDialog(85);
  initHelpGroup();
//  bApp->checkProgressDialog(86);
  initPropertyView();
//  bApp->checkProgressDialog(87);
  initGroupView();
//  bApp->checkProgressDialog(88);
  initControlMoveView();
//  bApp->checkProgressDialog(89);
//  initEventsView();
  bApp->checkProgressDialog(90);
//  initLogGroup();
  initStatusBar();
}

void BMainWindowStateGame::clear() {
  BMainWindowState::clear();
}

void BMainWindowStateGame::init() {
  BMainWindowState::init();
  initCentralGroup();
//  bApp->checkProgressDialog(95, 
//    QProgressDialog::tr("Loading control settings..."));
  initAIs();
  loadSettings();
  _central->viewWidget()->setFocus();
}

void BMainWindowStateGame::update() {
  BattleInfo battleInfo = _battle->battleInfo();

  battlePlayAction->setEnabled(Running != battleInfo.state);
  battlePauseAction->setEnabled( (Running == battleInfo.state) ||
    (Paused == battleInfo.state) );

  speedCB->setEnabled(true);
  speedCB->setCurrentItem(battleInfo.speedIndex);
  if (battleInfo.speedIndex == RealtimeSpeed)
    {
      battleRealtimeAction->setOn(true);
    }
  else if (battleInfo.speedIndex == SlowSpeed)
    {
      battleSlowAction->setOn(true);
    }
  else if (battleInfo.speedIndex == NormalSpeed)
    {
      battleNormalAction->setOn(true);
    }
  else if (battleInfo.speedIndex == FastSpeed)
    {
      battleFastAction->setOn(true);
    }
  else if (battleInfo.speedIndex == UltraFastSpeed)
    {
      battleUltraFastAction->setOn(true);
    }
  else
    {
      throw BInternalException(__FILE__, __LINE__,
        tr("Unknown battle speed: %1").arg(battleInfo.speedIndex));
    }

  _timeLabel->setText(battleInfo.modelTime.toString());

  shipsUngroupAction->setEnabled(_uiState->canUngroupSelection());
}

void BMainWindowStateGame::initFileGroup() {
  fileNewAction = new QAction( this, "fileNewAction" );
  fileNewAction->setIconSet( QIconSet( imageNew ) );
  fileOpenAction = new QAction( this, "fileOpenAction" );
  fileOpenAction->setIconSet( QIconSet( imageOpen ) );
  fileSaveAction = new QAction( this, "fileSaveAction" );
  fileSaveAction->setIconSet( QIconSet( imageSave ) );
  fileSaveAsAction = new QAction( this, "fileSaveAsAction" );
  fileExitAction = new QAction( this, "fileExitAction" );

  fileToolBar = new QToolBar( qApp->translate("BMainWindowState", fileToolBar_N), _mainWindow, DockTop ); 
  fileToolBar->setCloseMode(QDockWindow::Undocked);

  fileNewAction->addTo( fileToolBar );
  fileOpenAction->addTo( fileToolBar );
  fileSaveAction->addTo( fileToolBar );
  fileToolBar->hide();

  QPopupMenu* fileMenu = new QPopupMenu( _mainWindow );
  fileNewAction->addTo( fileMenu );
  fileOpenAction->addTo( fileMenu );
  fileSaveAction->addTo( fileMenu );
  fileSaveAsAction->addTo( fileMenu );
  fileMenu->insertSeparator();
  fileExitAction->addTo( fileMenu );
  _mainWindow->menuBar()->insertItem( qApp->translate("BMainWindowState", fileMenu_N ), fileMenu, -1, 0 );

  // signals and slots connections
  connect( fileNewAction, SIGNAL( activated() ), this, SLOT( fileNew() ) );
  connect( fileOpenAction, SIGNAL( activated() ), this, SLOT( fileOpen() ) );
  connect( fileSaveAction, SIGNAL( activated() ), this, SLOT( fileSave() ) );
  connect( fileSaveAsAction, SIGNAL( activated() ), this, SLOT( fileSaveAs() ) );
  connect( fileExitAction, SIGNAL( activated() ), this, SLOT( fileExit() ) );
  fileNewAction->setText( qApp->translate("BMainWindowState", fileNewAction_TT ) );
  fileNewAction->setMenuText( qApp->translate("BMainWindowState", fileNewAction_N) );
  fileNewAction->setAccel( CTRL+Key_N );
  fileNewAction->setStatusTip( qApp->translate("BMainWindowState", fileNewAction_ST ) );
  fileNewAction->setWhatsThis( qApp->translate("BMainWindowState", fileNewAction_WT ) );

  fileOpenAction->setText( qApp->translate("BMainWindowState", fileOpenAction_TT ) );
  fileOpenAction->setMenuText( qApp->translate("BMainWindowState", fileOpenAction_N) );
  fileOpenAction->setAccel( CTRL+Key_O);
  fileOpenAction->setStatusTip( qApp->translate("BMainWindowState", fileOpenAction_ST ) );
  fileOpenAction->setWhatsThis( qApp->translate("BMainWindowState", fileOpenAction_WT ) );

  fileSaveAction->setText( qApp->translate("BMainWindowState",fileSaveAction_TT  ) );
  fileSaveAction->setMenuText( qApp->translate("BMainWindowState", fileSaveAction_N) );
  fileSaveAction->setAccel( CTRL+Key_S);
  fileSaveAction->setStatusTip( qApp->translate("BMainWindowState", fileSaveAction_ST ) );
  fileSaveAction->setWhatsThis( qApp->translate("BMainWindowState", fileSaveAction_WT ) );

  fileSaveAsAction->setText( qApp->translate("BMainWindowState", fileSaveAsAction_TT) );
  fileSaveAsAction->setMenuText( qApp->translate("BMainWindowState", fileSaveAsAction_N ) );
  fileSaveAsAction->setAccel( QString::null );
  fileSaveAsAction->setStatusTip( qApp->translate("BMainWindowState", fileSaveAsAction_ST ) );
  fileSaveAsAction->setWhatsThis( qApp->translate("BMainWindowState", fileSaveAsAction_WT ) );

  fileExitAction->setText( qApp->translate("BMainWindowState", fileExitAction_TT) );
  fileExitAction->setMenuText( qApp->translate("BMainWindowState", fileExitAction_N) );
  fileExitAction->setAccel( QString::null );
  fileExitAction->setStatusTip( qApp->translate("BMainWindowState", fileExitAction_ST ) );
  fileExitAction->setWhatsThis( qApp->translate("BMainWindowState", fileExitAction_WT ) );

  connect(_mainWindow, SIGNAL(newScenario()), this, SLOT(fileOpen()));
}

void BMainWindowStateGame::fileSave() {
  QString cur = _battle->scenarioHeader()->fileName();
  QFileInfo fi(cur);
  QString curDir = QDir::convertSeparators(fi.dirPath(true));
  if ( curDir != QDir::convertSeparators(bApp->scenarioSaversDir())) {
    fileSaveAs();
  }
  else {
    _battle->save();
  }
}

void BMainWindowStateGame::fileSaveAs() {
  BScenarioSave ss(bApp->scenarioSaversDir(), 
    _battle->scenarioHeader()->fileName(), _mainWindow, "savescenariownd");
  ss.exec();
  if (ss.result() == QDialog::Accepted) {
    if (ss.fileName() == _battle->scenarioHeader()->fileName()) {
      _battle->save();
    }
    else {
      _battle->saveAs(ss.fileName());
    }
  }
}

void BMainWindowStateGame::initControlMoveView() {
  _controlMoveView = new BControlMoveView(this, _mainWindow, "controlmoveview");
  _mainWindow->addDockWindow(_controlMoveView, DockLeft, false);
//  _mainWindow->setDockEnabled(_controlMoveView, DockTornOff, false);
  _mainWindow->addDockWindow(_controlMoveView, DockRight, true);
  _mainWindow->setDockEnabled(_controlMoveView, DockTop, true);
  _mainWindow->setDockEnabled(_controlMoveView, DockBottom, true);
  connect(_uiState, SIGNAL(selectionChanged(const BUiSelectionInfo&)),
    _controlMoveView, SLOT(slotSelectionChanged(const BUiSelectionInfo&)));
  connect(_controlMoveView->view(), 
    SIGNAL(changeControlMode(const BAI::ControlModes, BattleObject*)),
    _ais, SLOT(setControlMode(const BAI::ControlModes, BattleObject*)));
  _controlMoveView->hide();
}
