/******************************************************************************/
/* BMainWindowStateGame -   BattleFleet              */
/******************************************************************************/

#ifndef BMainWindowStateGame_H
#define BMainWindowStateGame_H
static const char bmainwindowstategame_h_id[]="@(#) $Id: bmainwindowstategame.h,v 1.5 2005/02/15 16:43:34 Oleksiy Balabay Exp $"; static const char* bmainwindowstategame_h_id_id=bmainwindowstategame_h_id;
/** \file bmainwindowstategame.h
  \brief  BMainWindowStateGame  BattleFleet

     BMainWindowStateGame  BattleFleet
*/

#include "bmainwindowstate.h"

class QLabel;
class BScrollBar;
class QComboBox;
class BControlMoveView;

class BMainWindowStateGame: public BMainWindowState {
  Q_OBJECT
public:
  BMainWindowStateGame(Battle* battle, BMainWindow* mainWindow, 
    const char* name);
  virtual ~BMainWindowStateGame();
  virtual void init();
  virtual void update();
public slots:
  virtual void slotBattleInfoChanged(const BattleInfo& info);
protected:
  virtual void initBase();
  virtual QString stateName() const;
  virtual void clear();
  virtual QString defaultSettingsString() const;
protected:
  virtual void initFileGroup();
protected:
  QAction* fileSaveAction;
  QAction* fileSaveAsAction;
protected slots:
  virtual void fileSave();
  virtual void fileSaveAs();
protected:
  virtual void initControlMoveView();
protected:
  BControlMoveView* _controlMoveView;
};
#endif // BMainWindowStateGame_H
