/******************************************************************************/
/* BMainWindowStatePlay -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bmainwindowstateplay_cpp_id[]="@(#) $Id: bmainwindowstateplay.cpp,v 1.15 2005/03/13 08:31:09 Oleksiy Balabay Exp $"; static const char* bmainwindowstateplay_cpp_id_id=bmainwindowstateplay_cpp_id;

/** \file bmainwindowstateplay.cpp
  \brief  BMainWindowStatePlay  BattleFleet (impl.)

     BMainWindowStatePlay  BattleFleet
*/
#include <qcombobox.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>
#include <qstatusbar.h>
#include <qmessagebox.h>

#include "bmainwindowstateplay.h"
#include "bapplication.h"
#include "bmainwindow.h"
#include "bfactory.h"
#include "battle.h"
#include "bscenarioheader.h"
#include "blog.h"
#include "bpropertyview.h"
#include "bgroupview.h"
#include "beventsview.h"

#include "xpms/play.xpm"
#include "xpms/pause.xpm"

/** \class BMainWindowStatePlay
  \brief 


*/
/** \brief 
*/
BMainWindowStatePlay::BMainWindowStatePlay(Battle* battle, 
  BMainWindow* mainWindow, const char* name):BMainWindowState(battle, 
  mainWindow, name), _isFinished(false) {
  _central = 0;
  _mainWindow->setCaption(tr("%1. Film Mode - BattleFleet").arg(
    battle->scenarioHeader()->name()));
}

/** \brief 
*/
BMainWindowStatePlay::~BMainWindowStatePlay() {
  saveSettings();
  if (_central) {
    delete _central;
  }
  clear();
}

QString BMainWindowStatePlay::defaultSettingsString() const {
  //    ,     
  QString s = 
"\n"
"\n"
"\n"+
fileToolBar->caption()+","+
battleToolBar->caption()+","+
viewToolBar->caption()+","+
helpToolBar->caption()+",\n"+
"["+fileToolBar->caption()+",0,1,-1,-1,1]["+
battleToolBar->caption()+",0,0,-1,-1,1]["+
viewToolBar->caption()+",0,0,-1,-1,1]["+
helpToolBar->caption()+",0,0,-1,-1,1]\n"+
_mainWindow->logDockWindow()->caption()+",\n"+
"["+_mainWindow->logDockWindow()->caption()+",0,1,-1,141,1]\n"+
"\n"
"\n"
"\n"
"\n";
  return s;
}

void BMainWindowStatePlay::slotBattleInfoChanged(const BattleInfo& info) {
//  _timeLabel->setText(info.modelTime.toString());
  _propertyView->updateView();
  _groupView->updateView(info);
//  _eventsView->updateView(info);
  if (!_isFinished) {
    if (info.modelTime >= _battle->scenarioHeader()->endDate()) {
      _isFinished = true;
      QMessageBox::information(_mainWindow, tr("BattleFleet"),
        tr("The battle is finished"), QMessageBox::Ok);
      battlePause();
    }
  }

  update();
}

QString BMainWindowStatePlay::stateName() const {
  return "Play";
}

void BMainWindowStatePlay::initBase() {
  initFileGroup();
  initBattleGroup();
  initViewGroup();
  initGroupView();
  initPropertyView();
//  initEventsView();
  initToolsGroup();
  initHelpGroup();
//  initEventsView();
//  initLogGroup();
  initStatusBar();
}

void BMainWindowStatePlay::clear() {
  BMainWindowState::clear();
}

void BMainWindowStatePlay::init() {
  BMainWindowState::init();
  bApp->processEvents();
  initCentralGroup();
  loadSettings();
  _central->viewWidget()->setFocus();
}

void BMainWindowStatePlay::update() {
  BattleInfo battleInfo = _battle->battleInfo();

  battlePlayAction->setEnabled(Running != battleInfo.state);
  battlePauseAction->setEnabled( (Running == battleInfo.state) ||
    (Paused == battleInfo.state) );

  speedCB->setEnabled(true);
  speedCB->setCurrentItem(battleInfo.speedIndex);
  if (battleInfo.speedIndex == RealtimeSpeed)
    {
      battleRealtimeAction->setOn(true);
    }
  else if (battleInfo.speedIndex == SlowSpeed)
    {
      battleSlowAction->setOn(true);
    }
  else if (battleInfo.speedIndex == NormalSpeed)
    {
      battleNormalAction->setOn(true);
    }
  else if (battleInfo.speedIndex == FastSpeed)
    {
      battleFastAction->setOn(true);
    }
  else if (battleInfo.speedIndex == UltraFastSpeed)
    {
      battleUltraFastAction->setOn(true);
    }
  else
    {
      throw BInternalException(__FILE__, __LINE__,
        tr("Unknown battle speed: %1").arg(battleInfo.speedIndex));
    }
  _timeLabel->setText(battleInfo.modelTime.toString());
}

void BMainWindowStatePlay::initViewGroup() {
  BMainWindowState::initViewGroup();
  viewModeConnectAction->setEnabled(false);
  viewModeConnectAction->setVisible(false);
}
