/******************************************************************************/
/* BObserverCentral -   BattleFleet              */
/******************************************************************************/

#ifndef BObserverCentral_H
#define BObserverCentral_H
static const char bobservercentral_h_id[]="@(#) $Id: bobservercentral.h,v 1.8 2004/10/04 15:26:32 Oleksiy Balabay Exp $"; static const char* bobservercentral_h_id_id=bobservercentral_h_id;
/** \file bobservercentral.h
  \brief  BObserverCentral  BattleFleet

     BObserverCentral  BattleFleet
*/
#include <qmap.h>

#include <set>

#include "battleobserver.h"

class BScrollBar;
class BCentral;
class BattleObject;
typedef std::set<BattleObject*> BattleObjects;
class QMouseEvent;
class BOCEditState;
class BUiState;
struct BUiSelectionInfo;
class BCanvasShip;
class BCanvasConnection;

class BObserverCentral: public BattleObserver {
  Q_OBJECT
public:
  friend class BOCEditState;
  friend class BOCEditStateIdle;
  friend class BOCEditStateScale;
  friend class BOCEditStateMove;
  friend class BOCEditStateConnect;
  friend class BOCEditStateRect;
  friend class BOCEditStateSelect;

  BObserverCentral(BUiState* uiState, Battle* battle, QObject* parent, const char* name);
  virtual ~BObserverCentral();
  virtual void init();
  virtual BOCEditState* currentState(QMouseEvent* e);
  BattleObject* activeObject() const;
  const BattleObjects& selectedObjects() const;
  BCanvasShip* objAtPoint(const QPoint& p);
  BCanvasConnection* connectionAtPoint(const QPoint& p);
public slots:
  virtual void slotBattleInfoChanged(const BattleInfo& info);
  virtual void slotAboutToQuitBattle();
  virtual void slotSelectionChanged(const BUiSelectionInfo& selectionInfo);
protected:
  virtual void customEvent(QCustomEvent* e);
  virtual BCentral* createCentral(QWidget* parent, const char* name);
  void removeSelectedConnections();
  void removeConnection(BCanvasConnection* con);
protected:
  BCentral* _central;
  BOCEditState* _currentState;
  BUiState* _uiState;
private:
  BScrollBar* _vScrollBar;
  BScrollBar* _hScrollBar;
private:
  void emitMouseOver(const int canvasX, const int canvasY, 
    const QString& message) {
    emit mouseOver(canvasX, canvasY, message);
  }
signals:
  void mouseOver(const int canvasX, const int canvasY, 
    const QString& message);
};

#endif // BObserverCentral_H
