/******************************************************************************/
/* BObserverCentralEdit -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bobservercentraledit_cpp_id[]="@(#) $Id: bobservercentraledit.cpp,v 1.9 2004/10/13 05:33:51 Oleksiy Balabay Exp $"; static const char* bobservercentraledit_cpp_id_id=bobservercentraledit_cpp_id;

#include "bobservercentraledit.h"
#include "bcentraledit.h"
#include "bcanvasship.h"
#include "boceditstate.h"
#include "beventgroup.h"
#include "battle.h"
#include "battleobject.h"
#include "buistate.h"

/** \file bobservercentraledit.cpp
  \brief  BObserverCentralEdit  BattleFleet (impl.)

     BObserverCentralEdit  BattleFleet
*/

/** \class BObserverCentralEdit
  \brief 


*/
/** \brief 
*/
BObserverCentralEdit::BObserverCentralEdit(BUiState* uiState, Battle* battle,
  QObject* parent, const char* name)
  :BObserverCentral(uiState, battle, parent, name) {
  connect(battle, SIGNAL(battleObjectAdded(BattleObject*)),
    this, SLOT(slotBattleObjectAdded(BattleObject*)));
  connect(battle, SIGNAL(battleObjectRemoved(BattleObject*)),
    this, SLOT(slotBattleObjectRemoved(BattleObject*)));
}

/** \brief 
*/
BObserverCentralEdit::~BObserverCentralEdit(){
}

BCentral* BObserverCentralEdit::createCentral(QWidget* parent, const char* name) {
  BCentralEdit* c = new BCentralEdit(this, parent, name);
//  connect(c, SIGNAL(activeObjectChanged(BattleObject*)),
//    this, SIGNAL(activeObjectChanged(BattleObject*)));
  return c;
}

BOCEditState* BObserverCentralEdit::currentState(QMouseEvent* e) {
  if (e->type() == QEvent::MouseMove) {
    if ((dynamic_cast<BOCEditStateIdle*>(_currentState) != 0) &&
      (e->state() & QMouseEvent::LeftButton) &&
      (_uiState->editorMode() != BUiState::ConnectMode)){
      BCanvasShip* shp = objAtPoint(e->pos());
      if (shp) {
        delete _currentState;
        _currentState = new BOCEditStateMove(this, shp);
        return _currentState;
      }
    }
  }
  return BObserverCentral::currentState(e);
}

bool BObserverCentralEdit::eventFilter(QObject* /* o */, QEvent* e) {
  if ((e->type() != QEvent::KeyPress)&&(e->type() != QEvent::KeyRelease)) {
    return false;
  }
  QKeyEvent*event = (QKeyEvent*)e;
  if (e->type() == QEvent::KeyPress) {
    if ( event->isAutoRepeat() || !_commands.contains( event->key() ) ) {
      return false;
    }
    BCommand b = _commands[ event->key() ];
    switch ( b ) {
    case Delete: 
      {
        removeSelectedConnections();
        deleteObject();
        break;
      }
    default:
      return false;
    }
    return true;
  }
  else {
    return false;
  }
}

void BObserverCentralEdit::deleteObject() {
  _uiState->removeSelection();
}

void BObserverCentralEdit::init() {
  BObserverCentral::init();
  _central->installEventFilter(this);
  _commands.insert( Qt::Key_Delete, Delete );
}

void BObserverCentralEdit::slotBattleObjectAdded(BattleObject* o) {
  _central->addObjectOrGroup(o, _battle->battleInfo().modelTime);
}

void BObserverCentralEdit::slotBattleObjectRemoved(BattleObject* o) {
  _central->removeBattleObject(o);
}
