/******************************************************************************/
/* BObserverCentralGame -   BattleFleet              */
/******************************************************************************/

#ifndef BObserverCentralGame_H
#define BObserverCentralGame_H
static const char bobservercentralgame_h_id[]="@(#) $Id: bobservercentralgame.h,v 1.2 2004/10/04 15:27:40 Oleksiy Balabay Exp $"; static const char* bobservercentralgame_h_id_id=bobservercentralgame_h_id;
/** \file bobservercentralgame.h
  \brief  BObserverCentralGame  BattleFleet

     BObserverCentralGame  BattleFleet
*/
#include "bobservercentral.h"

class BObserverCentralGame: public BObserverCentral {
  Q_OBJECT
public:
  BObserverCentralGame(BUiState* uiState, Battle* battle, 
    QObject* parent, const char* name);
  virtual ~BObserverCentralGame();
  virtual void init();
protected:
  virtual BCentral* createCentral(QWidget* parent, const char* name);
  virtual bool eventFilter(QObject* o, QEvent* e);
private:
  void turnLeft(const bool r);
  void turnRight(const bool r);
  void accelerate(const bool r);
  void brake(const bool r);
  void processCommand(BattleObject* activeObject);
private:
  enum BCommand {
    TurnLeft,
    TurnRight,
    Accelerate,
    Brake,
    Delete
  };
  QMap<int, BCommand> _commands;
  bool _accelerate;
  bool _break;
  bool _turnLeft;
  bool _turnRight;
};

#endif // BObserverCentralGame_H
