/******************************************************************************/
/* BObserverCentralPlay -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bobservercentralplay_cpp_id[]="@(#) $Id: bobservercentralplay.cpp,v 1.6 2005/01/05 11:47:26 Oleksiy Balabay Exp $"; static const char* bobservercentralplay_cpp_id_id=bobservercentralplay_cpp_id;

#include <qdatetime.h>

#include "bobservercentralplay.h"
#include "bcentralplay.h"
#include "bprogramfactory.h"
#include "beventprogram.h"
#include "battle.h"
#include "battleobject.h"
#include "bunitsconsts.h"

/** \file bobservercentralplay.cpp
  \brief  BObserverCentralPlay  BattleFleet (impl.)

     BObserverCentralPlay  BattleFleet
*/

/** \class BObserverCentralPlay
  \brief 


*/
/** \brief 
*/
BObserverCentralPlay::BObserverCentralPlay(BUiState* uiState, Battle* battle,
  QObject* parent, const char* name)
  :BObserverCentral(uiState, battle, parent, name) {
  _turnLeft = _turnRight = _accelerate = _break = false;
}

/** \brief 
*/
BObserverCentralPlay::~BObserverCentralPlay(){
}

BCentral* BObserverCentralPlay::createCentral(QWidget* parent, const char* name) {
  return new BCentralPlay(this, parent, name);
}

void BObserverCentralPlay::init() {
  BObserverCentral::init();
//  _central->installEventFilter(this);
  _commands.insert( Qt::Key_Up, Accelerate );
  _commands.insert( Qt::Key_Left, TurnLeft );
  _commands.insert( Qt::Key_Right, TurnRight );
  _commands.insert( Qt::Key_Down, Brake );
}

bool BObserverCentralPlay::eventFilter(QObject* /* o */, QEvent* e) {
  if ((e->type() != QEvent::KeyPress)&&(e->type() != QEvent::KeyRelease)) {
    return false;
  }
  QKeyEvent*event = (QKeyEvent*)e;
  if (e->type() == QEvent::KeyPress) {
    if ( event->isAutoRepeat() || !_commands.contains( event->key() ) ) {
      return false;
    }
    BCommand b = _commands[ event->key() ];
    switch ( b ) {
    case TurnLeft:
      turnLeft( true );
      break;
    case TurnRight:
      turnRight( true );
      break;
    case Accelerate:
      accelerate( true );
      break;
    case Brake:
      brake( true );
      break;
    default:
      return false;
    }
    return true;
  }
  else if (e->type() == QEvent::KeyRelease) {
    if ( event->isAutoRepeat() || !_commands.contains( event->key() ) ) {
      return false;
    }
    BCommand b = _commands[ event->key() ];
    switch ( b ) {
    case TurnLeft:
      turnLeft( false );
      break;
    case TurnRight:
      turnRight( false );
      break;
    case Accelerate:
      accelerate( false );
      break;
    case Brake:
      brake( false );
      break;
    default:
      return false;
    }
    return true;
  }
  else {
    return false;
  }
}

void BObserverCentralPlay::turnLeft(const bool r) {
  BattleObject* o = activeObject();
  if (0 == o)
    return;
  _turnLeft = r;
  processCommand(o);
}

void BObserverCentralPlay::turnRight(const bool r) {
  BattleObject* o = activeObject();
  if (0 == o)
    return;
  _turnRight = r;
  processCommand(o);
}

void BObserverCentralPlay::accelerate(const bool r) {
  BattleObject* o = activeObject();
  if (0 == o)
    return;
  _accelerate = r;
  processCommand(o);
}

void BObserverCentralPlay::brake(const bool r) {
  BattleObject* o = activeObject();
  if (0 == o)
    return;
  _break = r;
  processCommand(o);
}

void BObserverCentralPlay::processCommand(BattleObject* /* activeObject */) {
/*  QDateTime dt = _battle->battleInfo().modelTime;
  BKinematicData kd = activeObject->kinematicData(dt);

  if (_turnLeft && _accelerate) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(
        -2*PI, activeObject->maxSpeed(), _battle), activeObject->name(), dt)
    );
  }
  else if (_turnLeft && _break) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(
      -2*PI, 0, _battle), activeObject->name(), dt)
    );
  }
  else if (_turnRight && _accelerate) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(2*PI, 
      activeObject->maxSpeed(), _battle), activeObject->name(), dt)
    );
  }
  else if (_turnRight && _break) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(2*PI, 0,
      _battle), activeObject->name(), dt)
    );
  }
  else if (_turnLeft) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(-2*PI, 
      kd.v(false), _battle), activeObject->name(), dt)
    );
  }
  else if (_turnRight) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(2*PI, 
        kd.v(false), _battle), activeObject->name(), dt)
    );
  }
  else if (_accelerate) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(0, 
      activeObject->maxSpeed(), _battle), activeObject->name(), dt)
    );
  }
  else if (_break) {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(0, 0,
      _battle), activeObject->name(), dt)
    );
  }
  else {
    _battle->postEvent(
      new BEventProgram(BProgramFactory::createTurnAccelerateProgram(0, 
      kd.v(false), _battle), activeObject->name(), dt)
    );
  }
*/
}
