/******************************************************************************/
/* BObserverCentralPlay -   BattleFleet              */
/******************************************************************************/

#ifndef BObserverCentralPlay_H
#define BObserverCentralPlay_H
static const char bobservercentralplay_h_id[]="@(#) $Id: bobservercentralplay.h,v 1.2 2004/05/20 13:37:15 Oleksiy Balabay Exp $"; static const char* bobservercentralplay_h_id_id=bobservercentralplay_h_id;
/** \file bobservercentralplay.h
  \brief  BObserverCentralPlay  BattleFleet

     BObserverCentralPlay  BattleFleet
*/
#include "bobservercentral.h"

class BObserverCentralPlay: public BObserverCentral {
  Q_OBJECT
public:
  BObserverCentralPlay(BUiState* uiState, Battle* battle, 
    QObject* parent, const char* name);
  virtual ~BObserverCentralPlay();
  virtual void init();
protected:
  virtual BCentral* createCentral(QWidget* parent, const char* name);
  virtual bool eventFilter(QObject* o, QEvent* e);
private:
  void turnLeft(const bool r);
  void turnRight(const bool r);
  void accelerate(const bool r);
  void brake(const bool r);
  void processCommand(BattleObject* activeObject);
private:
  enum BCommand {
    TurnLeft,
    TurnRight,
    Accelerate,
    Brake
  };
  QMap<int, BCommand> _commands;
  bool _accelerate;
  bool _break;
  bool _turnLeft;
  bool _turnRight;
};

#endif // BObserverCentralPlay_H
