/******************************************************************************/
/* BOptionsDialog -   BattleFleet              */
/******************************************************************************/

#ifndef BOptionsDialog_H
#define BOptionsDialog_H
static const char boptionsdialog_h_id[]="@(#) $Id: boptionsdialog.h,v 1.4 2005/02/20 14:45:00 Oleksiy Balabay Exp $"; static const char* boptionsdialog_h_id_id=boptionsdialog_h_id;
/** \file boptionsdialog.h
  \brief  BOptionsDialog  BattleFleet

     BOptionsDialog  BattleFleet
*/
#include "boptionsdialogbase.h"
#include "bunitsconsts.h"

class BException;

class BOptionsDialog: public BOptionsDialogBase {
  Q_OBJECT
public:

  BOptionsDialog(QWidget* parent, const char* name);
  virtual ~BOptionsDialog();
  BPresentationUnits presentationsUnits() const;
protected slots:
  virtual void accept();
private:
  void readOptions();
  void readUnitsPage();
  void writeUnitsPage();
  void readMiscPage();
  void writeMiscPage();

  BUnits unitFromString(const QString& unit);

  void setShipSizeBox(const BPresentationUnits& pu);
  void setDistanceBox(const BPresentationUnits& pu);
  void setSpeedBox(const BPresentationUnits& pu);
  void setArmorBox(const BPresentationUnits& pu);
  void setCaliberBox(const BPresentationUnits& pu);
private slots:
  virtual void slotResetHelp();
  virtual void writeOptions();
  virtual void slotHelp();

private:

  static const char* _unitStrings[];
};

#endif // BOptionsDialog_H
