/******************************************************************************/
/* BProgramFactory -   BattleFleet              */
/******************************************************************************/

#ifndef BProgramFactory_H
#define BProgramFactory_H
static const char bprogramfactory_h_id[]="@(#) $Id: bprogramfactory.h,v 1.12 2005/01/12 03:57:23 Oleksiy Balabay Exp $"; static const char* bprogramfactory_h_id_id=bprogramfactory_h_id;
/** \file bprogramfactory.h
  \brief  BProgramFactory  BattleFleet

     BProgramFactory  BattleFleet
*/
#include <qstring.h>
#include <qdom.h>

class BProgram;
class QDateTime;
class BException;
class Battle;
class BShip;

class BProgramFactory {
public:
  static BProgram* create(const QDomElement& e, 
    const Battle* battle);
  static BProgram* createTurnAccelerateProgram(const Battle* battle,
    const double* turnAngleRadians = 0, 
    const double* newSpeedMiles = 0,  
    const double *fabsA = 0,
    const double *turnRadius = 0);
  static BProgram* createTurnInSuccessionProgram(const Battle* battle,
    const double* turnAngleRadians = 0, 
    const double* newSpeedMiles = 0,  
    const double *fabsA = 0,
    const double *turnRadius = 0);
  static BProgram* createTurnSimultaneousProgram(const Battle* battle,
    const double* turnAngleRadians = 0, 
    const double* newSpeedMiles = 0,  
    const double *fabsA = 0,
    const double *turnRadius = 0);
  static BProgram* createStandByProgram(const double x, 
    const double y, const Battle* battle);
  static BProgram* createStandByProgram(const double x, 
    const double y, const double course,
    const double speed, const Battle* battle);
  static QDomElement tAPtoXml(QDomDocument& doc, const QString& type, 
    const double* turnAngleRadians, 
    const double* newSpeedMiles,  
    const double* fabsA,
    const double* turnRadius);
private:
  static BProgram* createTAProgram(const QString& type, 
    const Battle* battle, 
    const double* turnAngleRadians, 
    const double* newSpeedMiles,  
    const double* fabsA,
    const double* turnRadius);
};

#endif // BProgramFactory_H
