/******************************************************************************/
/* BProgramTurnAccelerate -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bprogramturnaccelerate_cpp_id[]="@(#) $Id: bprogramturnaccelerate.cpp,v 1.14 2005/01/15 16:44:51 Oleksiy Balabay Exp $"; static const char* bprogramturnaccelerate_cpp_id_id=bprogramturnaccelerate_cpp_id;

#include <math.h>

#include "bprogramturnaccelerate.h"
#include "bptastrategy.h"
#include "bptastrategybidir.h"
#include "bprogramfactory.h"


/** \file bprogramturnaccelerate.cpp
  \brief  BProgramTurnAccelerate  BattleFleet (impl.)

     BProgramTurnAccelerate  BattleFleet
*/

/** \class BProgramTurnAccelerate
  \brief 


*/
const QString BProgramTurnAccelerate::PROGRAM_TYPE_TURN_ACCELERATE = "turn_accelerate";
const QString BProgramTurnAccelerate::PROGRAM_TURN_ANGLE = "TurnAngle";
const QString BProgramTurnAccelerate::PROGRAM_TURN_RADIUS = "TurnRadius";
const QString BProgramTurnAccelerate::PROGRAM_FABS_A = "AbsA";
const QString BProgramTurnAccelerate::PROGRAM_NEW_SPEED = "NewSpeed";

const double MIN_SPEED_LIMIT = 0.01; // knots

/** \brief 

        XML.  
  parse()  -  

*/
BProgramTurnAccelerate::BProgramTurnAccelerate():
  _strategy(0) {
//  _strategy = new BPTAStrategySimple(this);
  _strategy = new BPTAStrategyBiDir(this);
}

/** \brief 

        XML 

*/
void BProgramTurnAccelerate::parseCustom(const Battle* battle,
  const double *x, const double *y, const double *course,
  const double *speed, const double *turnAngle,
  const double *turnRMiles, const double *newSpeed,
  const double *fabsA) {

  _strategy->parseCustom(battle, x, y, course, speed, turnAngle,
    turnRMiles, newSpeed, fabsA);
/*  _battle = battle;

  if (x) _x0 = *x;
  _x0Initialized = (x==0);

  if (y) _y0 = *y;
  _y0Initialized = (y==0);

  if (course) _course0 = *course;
  _course0Initialized = (course==0);

  if (speed) _speed0 = *speed;
  _speed0Initialized = (speed==0);
*/
}

/** \brief 
*/
BProgramTurnAccelerate::~BProgramTurnAccelerate(){
  delete _strategy;
}

BKinematicData BProgramTurnAccelerate::kinematicData(
  const QDateTime& t) const {
  return _strategy->kinematicData(t);
}

void BProgramTurnAccelerate::initProgramCustom(const BProgramData& programData) {
  _strategy->initProgramCustom(programData);
}

void BProgramTurnAccelerate::parseCustom( const QDomElement& element, 
  const Battle* battle) { 
  _strategy->parseCustom(element, battle);
}

BProgram* BProgramTurnAccelerate::clone() const {
  BProgramTurnAccelerate* p = new BProgramTurnAccelerate(*this);
  p->_strategy = _strategy->clone(p);
  return p;
}

QDomElement BProgramTurnAccelerate::toXml(QDomDocument& doc) const {
  QDomElement e = BProgram::toXml(doc);
  return _strategy->toXml(doc, e);
}

BProgram* BProgramTurnAccelerate::restOfProgram(const QDateTime& dt) const {
  BKinematicData kd1 = kinematicData(dt);
  BKinematicData kd0 = kinematicData(t0());
  double a, r, v, angle;
  _strategy->info(&r, &a, &v, &angle);
  angle = kd0.course() + angle - kd1.course();
  BProgram* p = BProgramFactory::createTurnAccelerateProgram(_battle,
    &angle, &v, &a, &r);
  return p;
}