/******************************************************************************/
/* BProgramTurnAccelerate -   BattleFleet              */
/******************************************************************************/

#ifndef BProgramTurnAccelerate_H
#define BProgramTurnAccelerate_H
static const char bprogramturnaccelerate_h_id[]="@(#) $Id: bprogramturnaccelerate.h,v 1.10 2005/01/15 16:44:51 Oleksiy Balabay Exp $"; static const char* bprogramturnaccelerate_h_id_id=bprogramturnaccelerate_h_id;
/** \file bprogramturnaccelerate.h
  \brief  BProgramTurnAccelerate  BattleFleet

     BProgramTurnAccelerate  BattleFleet
*/
#include <qdatetime.h>
#include <qwmatrix.h>

#include "bprogram.h"

class BPTAStrategy;
class BPTAStrategySimple;
class BPTAStrategyBiDir;
class BProgramFactory;

class BProgramTurnAccelerate: public BProgram {
  friend class BPTAStrategy;
  friend class BPTAStrategySimple;
  friend class BPTAStrategyBiDir;
  friend class BProgramFactory;
protected:
  BProgramTurnAccelerate();
  virtual void parseCustom(const Battle* battle,
    const double *x = 0, const double *y = 0, const double *course = 0,
    const double *speed = 0, const double *turnAngle = 0,
    const double *turnRMiles = 0, const double *newSpeed = 0,
    const double *fabsA = 0);
  virtual void initProgramCustom(const BProgramData& programData);
  virtual void parseCustom( const QDomElement& element, 
    const Battle* battle); 
  static const QString PROGRAM_TYPE_TURN_ACCELERATE;
  static const QString PROGRAM_TURN_ANGLE;
  static const QString PROGRAM_TURN_RADIUS;
  static const QString PROGRAM_FABS_A;
  static const QString PROGRAM_NEW_SPEED;
public:
  virtual ~BProgramTurnAccelerate();
  virtual BKinematicData kinematicData(const QDateTime& t) const;
  virtual BProgram* clone() const;
  virtual QDomElement toXml(QDomDocument& doc) const;
  virtual BProgram* restOfProgram(const QDateTime& dt) const;
protected:
  BPTAStrategy* _strategy;
};

#endif // BProgramTurnAccelerate_H
