/******************************************************************************/
/* BProgramTurnInSuccession -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bprogramturninsuccession_cpp_id[]="@(#) $Id: bprogramturninsuccession.cpp,v 1.6 2005/01/15 16:44:51 Oleksiy Balabay Exp $"; static const char* bprogramturninsuccession_cpp_id_id=bprogramturninsuccession_cpp_id;

#include "bprogramturninsuccession.h"
#include "bptastrategy.h"
#include "bprogramfactory.h"

/** \file bprogramturninsuccession.cpp
  \brief  BProgramTurnInSuccession  BattleFleet (impl.)

     BProgramTurnInSuccession  BattleFleet
*/

/** \class BProgramTurnInSuccession
  \brief 


*/
const QString BProgramTurnInSuccession::PROGRAM_TYPE_TURN_IN_SUCCESSION = "turn_in_succession";

/** \brief 
*/
BProgramTurnInSuccession::BProgramTurnInSuccession(){

}

/** \brief 
*/
BProgramTurnInSuccession::~BProgramTurnInSuccession(){

}

QDomElement BProgramTurnInSuccession::toXml(QDomDocument& doc) const
  {
  QDomElement e = BProgramTurnAccelerate::toXml(doc);
  e.setAttribute(PROGRAM_TYPE, PROGRAM_TYPE_TURN_IN_SUCCESSION);
  return e;
}

BProgram* BProgramTurnInSuccession::clone() const {
  BProgramTurnInSuccession* p = new BProgramTurnInSuccession(*this);
  p->_strategy = _strategy->clone(p);
  return p;
}

BProgram* BProgramTurnInSuccession::restOfProgram(const QDateTime& dt) const {
  BKinematicData kd1 = kinematicData(dt);
  BKinematicData kd0 = kinematicData(t0());
  double a, r, v, angle;
  _strategy->info(&r, &a, &v, &angle);
  angle = kd0.course() + angle - kd1.course();
  BProgram* p = BProgramFactory::createTurnInSuccessionProgram(_battle,
    &angle, &v, &a, &r);
  return p;
}
