/******************************************************************************/
/* BProgramTurnSimultaneous -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bprogramturnsimultaneous_cpp_id[]="@(#) $Id: bprogramturnsimultaneous.cpp,v 1.6 2005/01/15 16:44:51 Oleksiy Balabay Exp $"; static const char* bprogramturnsimultaneous_cpp_id_id=bprogramturnsimultaneous_cpp_id;

#include "bprogramturnsimultaneous.h"
#include "bptastrategy.h"
#include "bprogramfactory.h"

/** \file bprogramturnsimultaneous.cpp
  \brief  BProgramTurnSimultaneous  BattleFleet (impl.)

     BProgramTurnSimultaneous  BattleFleet
*/

/** \class BProgramTurnSimultaneous
  \brief 


*/
const QString BProgramTurnSimultaneous::PROGRAM_TYPE_TURN_SIMULTANEOUS = "turn_simultaneous";
/** \brief 
*/
BProgramTurnSimultaneous::BProgramTurnSimultaneous(){

}

/** \brief 
*/
BProgramTurnSimultaneous::~BProgramTurnSimultaneous(){

}

QDomElement BProgramTurnSimultaneous::toXml(QDomDocument& doc) const
  {
  QDomElement e = BProgramTurnAccelerate::toXml(doc);
  e.setAttribute(PROGRAM_TYPE, PROGRAM_TYPE_TURN_SIMULTANEOUS);
  return e;
}

BProgram* BProgramTurnSimultaneous::clone() const {
  BProgramTurnSimultaneous* p = new BProgramTurnSimultaneous(*this);
  p->_strategy = _strategy->clone(p);
  return p;
}

BProgram* BProgramTurnSimultaneous::restOfProgram(const QDateTime& dt) const {
  BKinematicData kd1 = kinematicData(dt);
  BKinematicData kd0 = kinematicData(t0());
  double a, r, v, angle;
  _strategy->info(&r, &a, &v, &angle);
  angle = kd0.course() + angle - kd1.course();
  BProgram* p = BProgramFactory::createTurnSimultaneousProgram(_battle,
    &angle, &v, &a, &r);
  return p;
}
