/******************************************************************************/
/* BPropertyView -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bpropertyview_cpp_id[]="@(#) $Id: bpropertyview.cpp,v 1.7 2005/03/07 15:34:38 Oleksiy Balabay Exp $"; static const char* bpropertyview_cpp_id_id=bpropertyview_cpp_id;

#include "bpropertyview.h"
#include "propertylist/propertyeditor.h"
#include "bseamap.h"
#include "bship.h"
#include "bapplication.h"
#include "bfactory.h"

/** \file bpropertyview.cpp
  \brief  BPropertyView  BattleFleet (impl.)

     BPropertyView  BattleFleet
*/

/** \class BPropertyView
  \brief 


*/
const char* B_PROPERTY_VIEW = 
  QT_TRANSLATE_NOOP("BPropertyView", "Properties");

/** \brief 
*/
BPropertyView::BPropertyView(BattleObserver* observer,
  QWidget* parent, const char* name)
  :QDockWindow(parent, name), _observer(observer) {
  _view = new PropertyList(this, "proplistview");
  setWidget(_view);
  setCloseMode(Always);
  setResizeEnabled(true);
  setMovingEnabled(true);
  setCaption(tr(B_PROPERTY_VIEW));
//  init();
  _view->show();
  connect(_view, SIGNAL(valueChanged(const BProperty&)),
    this, SLOT(slotValueChanged(const BProperty&)));
  updateView((BShip*)0);
}

/** \brief 
*/
BPropertyView::~BPropertyView(){
}

void BPropertyView::updateView(BShip* o) {
  _curState = ShipState;
  if (_shipState.get() == 0) {
    _shipState = std::auto_ptr<BPVStateShip>(
      bApp->appFactory()->createPVStateShip(_view, _observer));
  }
  _shipState->updateView(o);
  _updateTimeout.start();
}

void BPropertyView::updateView(BShipGroup* o) {
  _curState = ShipGroupState;
  if (_shipGroupState.get() == 0) {
    _shipGroupState = 
      std::auto_ptr<BPVStateShipGroup>(
      bApp->appFactory()->createPVStateShipGroup(_view, _observer));
  }
  _shipGroupState->updateView(o);
  _updateTimeout.start();
}

void BPropertyView::updateView() {
  //      ,    
  if ((_updateTimeout.elapsed() < 1000) && 
    (bApp->battle()->battleInfo().state == Running)) 
    return;
  if (_curState == ShipState) {
    _shipState->updateView();
  }
  else if (_curState == SeaMapState) {
    _seaMapState->updateView();
  }
  else if (_curState == ShipGroupState) {
    _shipGroupState->updateView();
  }
  _updateTimeout.start();
}

void BPropertyView::slotValueChanged(const BProperty& property) {
  if (_curState == ShipState) {
    _shipState->valueChanged(property);
  }
  else if (_curState == ShipGroupState) {
    _shipGroupState->valueChanged(property);
  }
  else if (_curState == SeaMapState) {
    _seaMapState->valueChanged(property);
  }
}

void BPropertyView::updateView(BSeaMap* o) {
  _curState = SeaMapState;
  if (_seaMapState.get() == 0) {
    _seaMapState = std::auto_ptr<BPVStateSeaMap>(
      bApp->appFactory()->createPVStateSeaMap(_view, _observer));
  }
  _seaMapState->updateView(o);
  _updateTimeout.start();
}
