/******************************************************************************/
/* BPropertyView -   BattleFleet              */
/******************************************************************************/

#ifndef BPropertyView_H
#define BPropertyView_H
static const char bpropertyview_h_id[]="@(#) $Id: bpropertyview.h,v 1.6 2005/01/05 11:47:26 Oleksiy Balabay Exp $"; static const char* bpropertyview_h_id_id=bpropertyview_h_id;
/** \file bpropertyview.h
  \brief  BPropertyView  BattleFleet

     BPropertyView  BattleFleet
*/

#include <qlistview.h>
#include <qstring.h>
#include <qdockwindow.h>
#include <qstringlist.h>
#include <qdatetime.h>

#include "bpvstate.h"

class PropertyList;
class BattleObject;
class BattleObserver;

extern const char* B_PROPERTY_VIEW;

class BPropertyView:public QDockWindow {
  Q_OBJECT
public:
  BPropertyView(BattleObserver* observer, QWidget* parent, const char* name);
  virtual ~BPropertyView();
  void updateView(BShip* o);
  void updateView(BShipGroup* o);
  void updateView(BSeaMap* o);
  void updateView();
private slots:
  void slotValueChanged(const BProperty& property);
private:
  std::auto_ptr<BPVStateIdle> _idleState;
  std::auto_ptr<BPVStateShip> _shipState;
  std::auto_ptr<BPVStateShipGroup> _shipGroupState;
  std::auto_ptr<BPVStateSeaMap> _seaMapState;
  enum PropertyViewStates {
    IdleState,
    ShipState,
    SeaMapState,
    ShipGroupState
  };
  PropertyViewStates _curState;
  PropertyList* _view;
  QTime _updateTimeout;
  BattleObserver* _observer;
};

#endif // BPropertyView_H
