/******************************************************************************/
/* BPTAStrategy -                 */
/******************************************************************************/

#ifndef BPTAStrategy_H
#define BPTAStrategy_H
static const char bptastrategy_h_id[]="@(#) $Id: bptastrategy.h,v 1.5 2005/01/15 16:44:51 Oleksiy Balabay Exp $"; static const char* bptastrategy_h_id_id=bptastrategy_h_id;
/** \file bptastrategy.h
  \brief  BPTAStrategy  

     BPTAStrategy  
*/
#include "bprogramturnaccelerate.h"

class BPTAStrategy {
public:
  BPTAStrategy(BProgramTurnAccelerate* program):_program(program) {} ;
  virtual ~BPTAStrategy(){};
  virtual BKinematicData kinematicData(const QDateTime& t) const = 0;
  virtual void initProgramCustom(const BProgramData& programData) = 0;
  virtual void parseCustom( const QDomElement& element, 
    const Battle* battle) = 0; 
  virtual void parseCustom(const Battle* battle,
  const double *x = 0, const double *y = 0, const double *course = 0,
  const double *speed = 0, const double *turnAngle = 0,
  const double *turnRMiles = 0, const double *newSpeed = 0,
  const double *fabsA = 0) = 0;
  virtual BPTAStrategy* clone(BProgramTurnAccelerate* newProgram) const = 0;
  virtual QDomElement toXml(QDomDocument& doc, QDomElement& e) const = 0;
  virtual void info(double* r, double* a, double* v, double* angle) const = 0;
protected:
  BProgramTurnAccelerate* _program;
};

#endif // BPTAStrategy_H
