/******************************************************************************/
/* BPTAStrategyBiDir -                 */
/******************************************************************************/

#ifndef BPTAStrategyBiDir_H
#define BPTAStrategyBiDir_H
static const char bptastrategybidir_h_id[]="@(#) $Id: bptastrategybidir.h,v 1.6 2005/01/16 15:33:40 Oleksiy Balabay Exp $"; static const char* bptastrategybidir_h_id_id=bptastrategybidir_h_id;
/** \file bptastrategybidir.h
  \brief  BPTAStrategyBiDir  

     BPTAStrategyBiDir  
*/
#include "bptastrategy.h"

class BPTAStrategyBiDir: public BPTAStrategy {
public:
  BPTAStrategyBiDir(BProgramTurnAccelerate* program);
  virtual void parseCustom(const Battle* battle,
    const double *x = 0, const double *y = 0, const double *course = 0,
    const double *speed = 0, const double *turnAngle = 0,
    const double *turnRMiles = 0, const double *newSpeed = 0,
    const double *fabsA = 0);
  virtual ~BPTAStrategyBiDir();
  virtual BKinematicData kinematicData(const QDateTime& t) const;
  virtual void initProgramCustom(const BProgramData& programData);
  virtual void parseCustom( const QDomElement& element, 
    const Battle* battle); 
  virtual BPTAStrategy* clone(BProgramTurnAccelerate* newProgram) const;
  virtual QDomElement toXml(QDomDocument& doc, QDomElement& e) const;
  virtual void info(double* r, double* a, double* v, double* angle) const;
private:
  virtual void initProgramTurn(const BProgramData& programData);
  virtual void initProgramAccelerate(const BProgramData& programData);
//  void debugDump();
private:
  //        
  double _baseLatitude;

  double _turnAngle;
  bool _turnRInitialized;
  double _turnR;
  double _turnRMiles;
  QWMatrix _mTurn;
  bool _fabsAInitialized;
  double _fabsA;
  double _acceleration;
  double _newSpeed;
  bool _newSpeedInitialized;
  //   
  double _k;
};

#endif // BPTAStrategyBiDir_H
