/******************************************************************************/
/* BScales -   BattleFleet              */
/******************************************************************************/

#ifndef BScales_H
#define BScales_H
static const char bscales_h_id[]="@(#) $Id: bscales.h,v 1.3 2004/08/27 15:54:02 Oleksiy Balabay Exp $"; static const char* bscales_h_id_id=bscales_h_id;
/** \file bscales.h
  \brief  BScales  BattleFleet

     BScales  BattleFleet
*/
#include <map>


class BInternalException;
class BRangeException;
class QCanvas;

#include "bseamap.h"

class BScaleType {
public:
  BScaleType(const double map0, const double map1,
    const int canvas0, const int canvas1, 
    const BSeaMap::BCoordinatesType type);
  ~BScaleType();
  int count() const;
  QString label(const int index);
  double labelCoordinate(const int index);
public:
  static const int FONT_SIZE;
private:
  void selectBestInterval();
  int countIntervals(const int interval) const;
private:
  const double _map0;
  const double _map1;
  const int _canvas0;
  const int _canvas1;
  const BSeaMap::BCoordinatesType _type;
private:
  int _bestInterval;
  int _count;
  int _seconds;
  int _label0;
private:
  static const int intervalsInSeconds[];
  static const int MAX_LINES;
  static const int MIN_LINES;
  static const double TEXT_PART_IN_INTERVAL;
  static const QString FORMAT_DMS;
  static const QString FORMAT_DM;
  static const QString FORMAT_D;
};

class BScales {
public:
  BScales(const BCoordTransformer* coordTransformer, QCanvas* canvas);
  ~BScales();
  void drawScale();
  void drawLines();
private:
  void clearScaleTypes();
private:
  const BCoordTransformer* _coordTransformer;
  QCanvas* _canvas;
  BScaleType* _xScale;
  BScaleType* _yScale;
};

#endif // BScales_H
