/******************************************************************************/
/* BScenarioHeaderEdit -     (impl.)            */
/******************************************************************************/
static const char bscenarioheaderedit_cpp_id[]="@(#) $Id: bscenarioheaderedit.cpp,v 1.5 2005/04/09 16:14:26 Oleksiy Balabay Exp $"; static const char* bscenarioheaderedit_cpp_id_id=bscenarioheaderedit_cpp_id;

#include <qpushbutton.h>
#include <qtextedit.h>
#include <qlayout.h>


#include "bscenarioheader.h"
#include "bscenarioheaderedit.h"
#include "bnewscenario.h"
#include "bapplication.h"

/** \file bscenarioheaderedit.cpp
  \brief  BScenarioHeaderEdit   (impl.)

     BScenarioHeaderEdit  
*/

/** \class BScenarioHeaderEdit
  \brief 


*/
/** \brief 
*/
BScenarioHeaderEdit::BScenarioHeaderEdit(const BScenarioHeader* header, 
  QWidget* parent, const char* name):QDialog(parent, name, true),
  _header(header){
  bApp->addWidgetHelp(this, 
    bApp->applicationDirPath()+"/"+"doc/edit_scenario_properties.html");
  QHBoxLayout* bottom = new QHBoxLayout;

  _help = new QPushButton(tr("&Help"), this, "help");
  _help->setAutoDefault(true);
  connect(_help, SIGNAL(clicked()), this, SLOT(slotHelp()));
  bottom->addWidget(_help);

  bottom->addStretch(1);

  _ok = new QPushButton(tr("&OK"), this, "ok");
  _ok->setDefault(true);
  _ok->setAutoDefault(true);
  connect(_ok, SIGNAL(clicked()), this, SLOT(slotOk()));
  bottom->addWidget(_ok);

  bottom->setSpacing(6);
//  bottom->setMargin(11);

  _cancel = new QPushButton(tr("&Cancel"), this, "cancel");
  _cancel->setDefault(false);
  _cancel->setAutoDefault(true);
  connect(_cancel, SIGNAL(clicked()), this, SLOT(slotCancel()));
  bottom->addWidget(_cancel);

  QVBoxLayout* main = new QVBoxLayout(this);
  _scenario = new BNewScenario(this, "new_scenario");
  _scenario->setScenarioHeader(_header);
//  _scenario->setMinimumSize(QSize(200,140).expandedTo(minimumSizeHint()));
//  _scenario->setSizePolicy(QSizePolicy(QSizePolicy::Preferred, 
//    QSizePolicy::Minimum, 1, 0));
  main->addWidget(_scenario);

  _description = new QTextEdit(this);
  _description->setTextFormat(PlainText);
  _description->setText(_header->description());
//  _description->setSizePolicy(QSizePolicy(QSizePolicy::Expanding, 
//    QSizePolicy::Expanding, 1, 10));
  main->addWidget(_description);

  main->addLayout(bottom);

  main->setSpacing(6);
  main->setMargin(11);

  resize( QSize(300, 200).expandedTo(minimumSizeHint()) );
//  setFixedSize(size());
//  setMinimumSize(size());
//  setMaximumSize(size());
  setCaption(tr("Scenario properties - Battlefleet"));
  _ok->setFocus();
}

/** \brief 
*/
BScenarioHeaderEdit::~BScenarioHeaderEdit(){
  bApp->removeWidgetHelp(this);
}

void BScenarioHeaderEdit::slotHelp() {
  bApp->showHelp(this);
}

QString BScenarioHeaderEdit::scenarioName() const {
  return _scenario->scenarioName();
}

QString BScenarioHeaderEdit::scenarioSide1Name() const {
  return _scenario->scenarioSide1Name();
}

QString BScenarioHeaderEdit::scenarioSide2Name() const {
  return _scenario->scenarioSide2Name();
}

QString BScenarioHeaderEdit::scenarioDescription() const {
  return _description->text();
}

QDateTime BScenarioHeaderEdit::scenarioStartDate() const {
  return _scenario->scenarioStartDate();
}

void BScenarioHeaderEdit::slotOk() {
  if (_scenario->checkValidity())
    accept();
}

void BScenarioHeaderEdit::slotCancel() {
  reject();
}
