/******************************************************************************/
/* BScenarioHeaderEdit -                 */
/******************************************************************************/

#ifndef BScenarioHeaderEdit_H
#define BScenarioHeaderEdit_H
static const char bscenarioheaderedit_h_id[]="@(#) $Id: bscenarioheaderedit.h,v 1.1 2004/10/13 05:33:53 Oleksiy Balabay Exp $"; static const char* bscenarioheaderedit_h_id_id=bscenarioheaderedit_h_id;
/** \file bscenarioheaderedit.h
  \brief  BScenarioHeaderEdit  

     BScenarioHeaderEdit  
*/
#include <qdialog.h>
#include <qdatetime.h>

class BNewScenario;
class QTextEdit;
class BScenarioHeader;

class BScenarioHeaderEdit: public QDialog {
  Q_OBJECT
public:
  BScenarioHeaderEdit(const BScenarioHeader* header, 
    QWidget* parent, const char* name=0);
  virtual ~BScenarioHeaderEdit();
  QDateTime scenarioStartDate() const;
  QString scenarioName() const;
  QString scenarioSide1Name() const;
  QString scenarioSide2Name() const;
  QString scenarioDescription() const;
private slots:
  void slotHelp();
  void slotOk();
  void slotCancel();
private:
  QPushButton* _ok;
  QPushButton* _cancel;
  QPushButton* _help;
  BNewScenario* _scenario;
  QTextEdit* _description;
  const BScenarioHeader* _header;
};

#endif // BScenarioHeaderEdit_H
