/******************************************************************************/
/* BScenarioSave -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bscenariosave_cpp_id[]="@(#) $Id: bscenariosave.cpp,v 1.3 2005/04/03 14:22:25 Oleksiy Balabay Exp $"; static const char* bscenariosave_cpp_id_id=bscenariosave_cpp_id;

#include <qlayout.h>
#include <qlineedit.h>
#include <qfileinfo.h>
#include <qmessagebox.h>
#include <qpushbutton.h>

#include "bscenariosave.h"
#include "bscenariotable.h"
#include "bapplication.h"

/** \file bscenariosave.cpp
  \brief  BScenarioSave  BattleFleet (impl.)

     BScenarioSave  BattleFleet
*/

/** \class BScenarioSave
  \brief 


*/
/** \brief 
*/
BScenarioSave::BScenarioSave(const QString& dir, const QString& fileName, 
  QWidget* parent, const char* name)
  :BScenarioSaveBase(parent, name, true), _dir(dir), _baseFileName(fileName) {
  //       
//  bApp->addWidgetHelp(this, 
//    bApp->applicationDirPath()+"/"+"doc/scenariosave.html");
  buttonHelp->hide();
  initSaveTable();
  slotFileChanged(fileName);
//  setFixedSize(500, 350);
}

/** \brief 
*/
BScenarioSave::~BScenarioSave(){
//  bApp->removeWidgetHelp(this);
}

void BScenarioSave::initSaveTable() {
  _table = new BScenarioTable(_dir, _tableFrame, "savescenario");
  QLayout* layout = new QHBoxLayout(_tableFrame);
  layout->add(_table);
  _table->selectScenario(_baseFileName);
  _table->show();
  connect(_table, SIGNAL(fileChanged(const QString&)), 
    this, SLOT(slotFileChanged(const QString&)));

//  connect(_table, SIGNAL(accepted()), this, SLOT(accept()));
}

void BScenarioSave::slotFileChanged(const QString& fileName){
  QFileInfo fi(fileName);
  if (_fileName->text() != fi.fileName()) {
    _fileName->setText(fi.fileName());
  }
}

QString BScenarioSave::fileName() const {
  return _dir+"/"+_fileName->text();
}

void BScenarioSave::slotBeforeAccept() {
  QFileInfo fi(fileName());
  if (fi.exists()) {
    int res = QMessageBox::question(this, 
      tr("File exists"),
      tr("File \n'%1'\nalready exists. Do you want to overwrite it?").arg(
      fileName()), 
      QMessageBox::Yes|QMessageBox::Default, 
      QMessageBox::No|QMessageBox::Escape);

    if (QMessageBox::Yes == res) {
      accept();
    }
  }
  else {
    accept();
  }
}

void BScenarioSave::slotFileDoubleClicked() {
  slotFileChanged(_table->currentFileName());
  slotBeforeAccept();
}

void BScenarioSave::slotTextChanged(const QString& fileName) {
  buttonOk->setEnabled(!fileName.isEmpty());
}

void BScenarioSave::slotHelp() {
  bApp->showHelp(this);
}

