/******************************************************************************/
/* BScenarioSelection -   BattleFleet              */
/******************************************************************************/

#ifndef BScenarioSelection_H
#define BScenarioSelection_H
static const char bscenarioselection_h_id[]="@(#) $Id: bscenarioselection.h,v 1.7 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* bscenarioselection_h_id_id=bscenarioselection_h_id;
/** \file bscenarioselection.h
  \brief  BScenarioSelection  BattleFleet

     BScenarioSelection  BattleFleet
*/
#include "bscenarioselectionbase.h"
#include "bapplication.h"

class BScenarioTable;
class BScenarioTableEdit;
class BNewScenario;
class BDateEdit;

class BScenarioSelection : public BScenarioSelectionBase {
  Q_OBJECT
public:
  enum BPages {
    NewPage = 0,
    OpenPage = 1
  };
  BScenarioSelection(QWidget* parent = 0, BPages page = NewPage);
  virtual ~BScenarioSelection();
  QString scenarioFileName() const;
  BAppModes applicationMode() const;
  QDateTime scenarioStartDate() const;
  bool exit() const {
    return _exit;
  }
public slots:
  void slotTableCurrentChanged(int row, int col);
private slots:
  virtual void buttonToggled(bool on);
  void slotCurrentChanged(QWidget* w);
  virtual void slotBeforeOk();
  virtual void slotBeforeCancel();
  virtual void slotBeforeExit();
  virtual void slotHelp();
  void showBallonHelp();
private:
  void initPlayPage(BPages page);
  void initEditPage(BPages page);
  void initGamePage(BPages page);
  BScenarioTable* currentTable() const;
  void updateDescription();
  void updateDateEdit();
private:
  BScenarioTable* _playOpenTable;
  BNewScenario* _editNewTable;
  BScenarioTable* _editOpenTable;
  BScenarioTable* _gameNewTable;
  BScenarioTable* _gameOpenTable;
  bool _initialized;
  BDateEdit* _playDateEdit;
  BDateEdit* _gameDateEdit;
  bool _exit;
//  QString _scenarioFileName;
};

#endif // BScenarioSelection_H
