/******************************************************************************/
/* BScenarioTable -   BattleFleet              */
/******************************************************************************/

#ifndef BScenarioTable_H
#define BScenarioTable_H
static const char bscenariotable_h_id[]="@(#) $Id: bscenariotable.h,v 1.5 2004/10/10 10:18:21 Oleksiy Balabay Exp $"; static const char* bscenariotable_h_id_id=bscenariotable_h_id;
/** \file bscenariotable.h
  \brief  BScenarioTable  BattleFleet

     BScenarioTable  BattleFleet
*/
#include <qtable.h>
#include <qdatetime.h>

extern const char * EMPTY_SCENARIO;
extern const char * UNKNOWN_SIDE1;
extern const char * UNKNOWN_SIDE2;

class BScenarioTable: public QTable {
  Q_OBJECT
public:
  BScenarioTable(const QString& dirName, QWidget* parent, const char* name);
  virtual ~BScenarioTable();
  QString currentFileName() const;
  QString currentDescription() const;
  QDateTime currentBeginDate() const;
  QDateTime currentEndDate() const;
  void selectScenario(const QString& fileName);
private slots:
  void slotDoubleClicked(int row, int column, int button, 
    const QPoint& mousePos);
  void slotCurrentChanged(int row, int column);
signals:
  void accepted();
  void fileChanged(const QString& fileName);
protected:
  enum BColumns {
    SideOneColumn = 0,
    SideTwoColumn = 1,
    NameColumn = 2,
    BeginDateColumn = 3,
    EndDateColumn = 4,
    FileNameColumn = 5,
    DescriptionColumn = 6,
    CountColumns
  };
  QString _baseDir;
};

/*class BScenarioTableEdit: public BScenarioTable {
  Q_OBJECT
public:
  BScenarioTableEdit(QWidget* parent, const char* name);
  virtual ~BScenarioTableEdit();
  static const QString NEW_SCENARIO_FILE_NAME;
};
*/
#endif // BScenarioTable_H
