/******************************************************************************/
/* BScrollBar -   Battlefleet  (impl.)            */
/******************************************************************************/
static const char bscrollbar_cpp_id[]="@(#) $Id: bscrollbar.cpp,v 1.4 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* bscrollbar_cpp_id_id=bscrollbar_cpp_id;

#include "bscrollbar.h"

/** \file bscrollbar.cpp
  \brief  BScrollBar  Battlefleet (impl.)

     BScrollBar  Battlefleet
*/

/** \class BScrollBar
  \brief 


*/
/** \brief 
*/
BScrollBar::BScrollBar(QWidget* parent, const char* name)
  :QScrollView(parent, name), _resizeSignalProcessing(false) {
  setFrameStyle(QFrame::NoFrame);
  viewport()->hide();
  setOrientation(Horizontal);
  setDragAutoScroll(false);
  connect(this, SIGNAL(contentsMoving(int, int)),
    this, SLOT(contentsMovingSlot(int, int)));
  connect(this, SIGNAL(horizontalSliderReleased()),
    this, SLOT(horizontalSliderReleasedSlot()));
  connect(this, SIGNAL(verticalSliderReleased()),
    this, SLOT(verticalSliderReleasedSlot()));
}

/** \brief 
*/
BScrollBar::~BScrollBar(){

}

Qt::Orientation BScrollBar::orientation() const {
  return orient;
}

void BScrollBar::setOrientation(const Orientation orientation) {
  orient = orientation;
  if (orient == Horizontal) {
    setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
    setVScrollBarMode(QScrollView::AlwaysOff);
    setHScrollBarMode(QScrollView::AlwaysOn);
    setMaximumWidth(32767);
    setFixedHeight(horizontalScrollBar()->height());
  }
  else {
    setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Expanding);
    setHScrollBarMode(QScrollView::AlwaysOff);
    setVScrollBarMode(QScrollView::AlwaysOn);
    setMaximumHeight(32767);
    setFixedWidth(verticalScrollBar()->width());
  }
}

void BScrollBar::setVisiblePartSlot(Orientation oR, int pos, int range) {
  if (orient != oR)
    return;
  _resizeSignalProcessing = true;
  if (Horizontal == oR) {
    resizeContents(range, 0);
    setContentsPos(pos, 0);
  }
  else {
    resizeContents(0, range);
    setContentsPos(0, pos);
  }
  _resizeSignalProcessing = false;
}

void BScrollBar::contentsMovingSlot(int x, int y) {
  if (_resizeSignalProcessing)
    return;
  if (Horizontal == orientation()) {
    if (isHorizontalSliderPressed())
      return;
    emit contentsMoved(Horizontal, x);
  }
  else {
    if (isVerticalSliderPressed())
      return;
    emit contentsMoved(Vertical, y);
  }
}

void BScrollBar::horizontalSliderReleasedSlot() {
  if (_resizeSignalProcessing)
    return;
  emit contentsMoved(Horizontal, contentsX());
}

void BScrollBar::verticalSliderReleasedSlot() {
  if (_resizeSignalProcessing)
    return;
//  qDebug("Vertical slider: size=%d, pos=%d", contentsHeight(), contentsY());
  emit contentsMoved(Vertical, contentsY());;
}