/******************************************************************************/
/* BShipGroup -   BattleFleet              */
/******************************************************************************/

#ifndef BShipGroup_H
#define BShipGroup_H
static const char bshipgroup_h_id[]="@(#) $Id: bshipgroup.h,v 1.11 2005/01/24 03:50:43 Oleksiy Balabay Exp $"; static const char* bshipgroup_h_id_id=bshipgroup_h_id;
/** \file bshipgroup.h
  \brief  BShipGroup  BattleFleet

     BShipGroup  BattleFleet
*/
#include "battleobject.h"

class BShipGroupState;

class BShipGroup: public BattleObject {
public:
  BShipGroup(BattleObject* parent, const QString name = "");
  virtual ~BShipGroup();
  virtual void setSide(const int side);
  virtual BKinematicData kinematicData(const QDateTime& t) const;
  virtual BProgramData programData(const QDateTime& t) const;
  virtual void setProgram(BProgram* program, const QDateTime& t);
  virtual void parse(const QDomElement& element);
  virtual BattleObjects objs(BSelectionTypes selType = TreeSelectionType) const;
  virtual QImage image() const;
  virtual void setFlagShip(BattleObject* flagShip);
  virtual void insertChild(BattleObject* obj);
  virtual void removeChild(BattleObject* obj);
  virtual bool isGroup() const;
  virtual BattleObject* find(const QString& objectName) const;
  virtual QDomElement toXml(QDomDocument& doc, bool elementOnly = false) const;
  virtual void setParentControl(bool isOn);
  virtual double availableSpeed(const QDateTime& t) const;
  virtual double availableTurnRadius(const QDateTime& t) const;
  virtual double availableAcceleration(const QDateTime& t) const;
public:
  static bool isTurnInSuccessionEnabled(BattleObject* o,
    const QDateTime& t0, double lk);
public:
  static const QString SHP_SHIP_GROUP;
  static const QString SHP_SHIP_GROUP_NAME;
private:
  void parseAttributes(const QDomElement& element);
private:
  BShipGroupState* _state;
  BattleObjects _children;
};

#endif // BShipGroup_H
