/******************************************************************************/
/* BShipGroupState -   BattleFleet              */
/******************************************************************************/

#ifndef BShipGroupState_H
#define BShipGroupState_H
static const char bshipgroupstate_h_id[]="@(#) $Id: bshipgroupstate.h,v 1.3 2004/06/13 07:24:15 Oleksiy Balabay Exp $"; static const char* bshipgroupstate_h_id_id=bshipgroupstate_h_id;
/** \file bshipgroupstate.h
  \brief  BShipGroupState  BattleFleet

     BShipGroupState  BattleFleet
*/
#include <qimage.h>

#include "bkinematicdata.h"
#include "borderalgorithms.h"

class QDateTime;
class BShipGroup;
class BShip;
class BException;
class BProgram;

class BShipGroupState {
public:
  BShipGroupState(BShipGroup* shipGroup);
  virtual ~BShipGroupState();
  virtual BShip* selectFlagShip() = 0;
  virtual void setProgram(BProgram* program, const QDateTime& t) = 0;
  virtual BKinematicData kinematicData(const QDateTime& t) const = 0;
  virtual BProgramData programData(const QDateTime& t) const = 0;
protected:
  BShipGroup* _shipGroup;
};

class BShipGroupStateG : public BShipGroupState {
public:
  BShipGroupStateG(BShipGroup* shipGroup);
  virtual ~BShipGroupStateG();
  virtual BShip* selectFlagShip();
  virtual void setProgram(BProgram* program, const QDateTime& t);
  virtual BKinematicData kinematicData(const QDateTime& t) const;
  virtual BProgramData programData(const QDateTime& t) const;
private:
  void orderObjectsInGroup(const QDateTime& t0) const;
//  double objectWeight(const QDateTime& t0,const BattleObject* first, const BattleObject* second,
//    const double course) const;
private:
  mutable BShipsOrder _shipsOrder;
  mutable double _longitudeCoef;
};


#endif // BShipGroupState_H
