/******************************************************************************/
/* BShipGroupStateD -   BattleFleet              */
/******************************************************************************/

#ifndef BShipGroupStateD_H
#define BShipGroupStateD_H
static const char bshipgroupstated_h_id[]="@(#) $Id: bshipgroupstated.h,v 1.5 2005/01/24 03:50:44 Oleksiy Balabay Exp $"; static const char* bshipgroupstated_h_id_id=bshipgroupstated_h_id;
/** \file bshipgroupstated.h
  \brief  BShipGroupStateD  BattleFleet

     BShipGroupStateD  BattleFleet
*/
#include <vector>

#include <qdatetime.h>

#include "bshipgroupstate.h"
#include "borderalgorithms.h"


class BShipGroupStateD: public BShipGroupState {
public:
  BShipGroupStateD(BShipGroup* shipGroup, const QDateTime& t0);
  virtual ~BShipGroupStateD();
  virtual BShip* selectFlagShip();
  virtual void setProgram(BProgram* program, const QDateTime& t);
  virtual BKinematicData kinematicData(const QDateTime& t) const;
  virtual BProgramData programData(const QDateTime& t) const;
  static void orderObjectsInGroup(const BattleObjects& objs,
    BShipsOrder& shipsOrder, const QDateTime& t0, double longitudeCoef);
private:
  void orderObjectsInGroup(const QDateTime& t0);
//  double objectWeight(const QDateTime& t0,const BattleObject* first, const BattleObject* second,
//    const double course) const;
private:
  BShipsOrder _shipsOrder;
  double _longitudeCoef;
};

#endif // BShipGroupStateD_H
