/******************************************************************************/
/* BShips -   BattleFleet              */
/******************************************************************************/

#ifndef BShips_H
#define BShips_H
static const char bships_h_id[]="@(#) $Id: bships.h,v 1.6 2004/08/27 15:54:03 Oleksiy Balabay Exp $"; static const char* bships_h_id_id=bships_h_id;
/** \file bships.h
  \brief  BShips  BattleFleet

     BShips  BattleFleet
*/
#include <qmap.h>

#include <qstring.h>

#include "bshipgroup.h"
#include "bexception.h"
#include "bship.h"

class BShips: public BShipGroup {
private:
  typedef QMap<QString, BShip*> BShipsMap;
public:
  typedef BShipsMap::iterator iterator;
  typedef BShipsMap::const_iterator const_iterator;
  BShips();
  virtual ~BShips();
  iterator begin();
  const_iterator begin() const;
  iterator end();
  const_iterator end() const;
  BShip* ship(const QString& name);
  void addShipsFromFile(const QString& fileName);
  void initAfterParse();
  void removeUnusedShips();
  void save(const QString& fileName);
  const BShipGroup* unUsedShips() const;
  void setUnused(BattleObject* bo);
private:
  ///       
  BFileException addFileName(const BConfigException& e);
  void loadDocument(QDomDocument& doc, QFile& file);
  void clearShipsMap();
  virtual QDomDocument toXml() const;
  void appendObjects(QDomDocument& doc, QDomElement& element) const;
  void checkUnique(BShipGroup* group);
private:
  QString _fileName;
  BShipsMap _shipsMap;
  BShipGroup* _initShipsGroup;
};

#endif // BShips_H
