/******************************************************************************/
/* BShipsListView -   BattleFleet              */
/******************************************************************************/

#ifndef BShipsListView_H
#define BShipsListView_H
static const char bshipslistview_h_id[]="@(#) $Id: bshipslistview.h,v 1.4 2004/10/14 17:44:55 Oleksiy Balabay Exp $"; static const char* bshipslistview_h_id_id=bshipslistview_h_id;
/** \file bshipslistview.h
  \brief  BShipsListView  BattleFleet

     BShipsListView  BattleFleet
*/
#include <qlistview.h>
#include <qstring.h>
#include <qdockwindow.h>

class BattleObject;
class BShipGroup;

class BShipsListView: public QListView {
  Q_OBJECT
public:
  BShipsListView(QWidget *parent = 0, const char *name = 0);
  virtual ~BShipsListView();
  void showBattleObject(const BattleObject* battleObject);
  virtual void setOpen(QListViewItem* item, bool open);
  void updateView(const BattleObject* unUsedShips);
  void addBattleObject(const BattleObject* battleObject);
public:
  QPixmap* folderClosed;
  QPixmap* folderOpen;
//  QPixmap* shipUsed;
//  QPixmap* shipNotUsed;
protected:
  virtual QDragObject* dragObject();
private:
  void parseBattleObject(QListViewItem* parent, 
    const BattleObject* battleObject);
};

extern const char* B_SHIPS_DB_VIEW_CAPTION;

class BShipsDbView: public QDockWindow {
  Q_OBJECT
public:
  BShipsDbView(QWidget* parent, const char* name);
  virtual ~BShipsDbView();
  void updateView(const BattleObject* unUsedShips);
  void addShipsFromFile(const QString& fileName);
private:
  void init();
  BShipGroup* loadShipGroupFromFile(const QString& fileName);
private:
  BShipsListView* _view;
};
#endif // BShipsListView_H
