/******************************************************************************/
/* BTmpFiles -     (impl.)            */
/******************************************************************************/
static const char btmpfiles_cpp_id[]="@(#) $Id: btmpfiles.cpp,v 1.2 2005/01/21 16:25:03 Oleksiy Balabay Exp $"; static const char* btmpfiles_cpp_id_id=btmpfiles_cpp_id;


#include <qfileinfo.h>
#ifdef Q_WS_WIN
#include <windows.h>
#include <winbase.h>
#endif
#include <qdir.h>
#include <stdlib.h>
#include <qfile.h>


#include "btmpfiles.h"
#include "bexception.h"

/** \file btmpfiles.cpp
  \brief  BTmpFiles   (impl.)

     BTmpFiles  
*/

/** \class BTmpFiles
  \brief 


*/
BTmpFiles* BTmpFiles::_instance = 0;

/** \brief 
*/
BTmpFiles::BTmpFiles(const QString& tmpDir){
  QString t = tmpDir;
  if (t.isEmpty()) {
    t = QFile::decodeName(getenv("TEMP"));
    if (t.isEmpty() || (!checkDir(t))) {
      t = QFile::decodeName(getenv("TMP"));
      if (t.isEmpty() || (!checkDir(t))) {
        t = ".";
        if (t.isEmpty() || (!checkDir(t))) {
          throw BConfigException(__FILE__, __LINE__,
          qApp->translate("BTmpFiles", "Environment variables TEMP and "
          "TMP are not set. Setup any of these variables to point to "
          "temporary directory"));
        }
      }
    }
  }
  _tmpDir = t;
}

/** \brief 
*/
BTmpFiles::~BTmpFiles(){

}

BTmpFiles* BTmpFiles::instance(const QString& tmpDir) {
  if (_instance == 0)
    _instance = new BTmpFiles(tmpDir);
  return _instance;
}

bool BTmpFiles::checkDir(const QString& tmpDir) {
  QFileInfo fi(tmpDir);
  return (fi.exists() && fi.isDir() && fi.isWritable());
}

QString BTmpFiles::createFileName(const QString& baseName) {
  QFileInfo fi(baseName);
  QString fn = fi.baseName(false);
  QFileInfo fi1;
  QDir d(_tmpDir);
  int i = 0;
  do {
    QString s = fn+QString::number(i++)+"."+fi.extension();
    fi1.setFile(d, s);
    if (!fi1.exists())
      return fi1.absFilePath();
  } while (true);
  return ""; //keep compiler happy
}

QString BTmpFiles::createFileCopy(const QString& baseName) {
  QString tmpFileName = createFileName(baseName);
#ifdef Q_WS_WIN
  int rez = CopyFileA((const char*)QDir::convertSeparators(baseName).local8Bit(),
    (const char*)QDir::convertSeparators(tmpFileName).local8Bit(), true);
  if (rez == 0) {// fails
    LPVOID lpMsgBuf;
    int gle = GetLastError();
    FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM | 
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        gle,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &lpMsgBuf,
        0,
        NULL 
    );
    // Display the string.
    QString errMsg = qApp->translate("BTmpFiles",
      "Error while copy from '%1' to '%2'").arg(baseName).arg(
      tmpFileName)+"\n"+QString::fromLocal8Bit((const char*)lpMsgBuf);
    // Free the buffer.
    LocalFree( lpMsgBuf );
    throw BConfigException(__FILE__, __LINE__,
      errMsg);
  }
#else
  throw BInternalException(__FILE__, __LINE__,
    "FileCopy not implemented (yet)");
#endif
  return tmpFileName;
}
