/******************************************************************************/

/* BUiUtils -   BattleFleet  (impl.)            */

/******************************************************************************/

static const char buiutils_cpp_id[]="@(#) $Id: buiutils.cpp,v 1.2 2004/05/08 15:18:53 Oleksiy Balabay Exp $"; static const char* buiutils_cpp_id_id=buiutils_cpp_id;



#include <qsettings.h>



#include "buiutils.h"

#include "bapplication.h"

#include "bseamap.h"



/** \file buiutils.cpp

  \brief  BUiUtils  BattleFleet (impl.)



     BUiUtils  BattleFleet

*/



/** \class BUiUtils

  \brief 





*/

/** \brief 

*/

BUiUtils::BUiUtils(const BPresentationUnits pUnits):_pUnits(pUnits){

}



BUiUtils::BUiUtils(){

  _pUnits = readConfig(bApp->settings());

}



/** \brief 

*/

BUiUtils::~BUiUtils(){



}



BPresentationUnits BUiUtils::readConfig(QSettings* settings) {

  BPresentationUnits pu;

  settings->beginGroup(S_OPTIONS);

    settings->beginGroup(S_OPTIONS_UNITS);

      pu.shipSize = static_cast<BUnits>(

        settings->readNumEntry(S_OPTIONS_UNITS_SHIP_SIZE, mUnit));

      pu.distance = static_cast<BUnits>(

        settings->readNumEntry(S_OPTIONS_UNITS_DISTANCE, cableUnit));

      pu.speed = static_cast<BUnits>(

        settings->readNumEntry(S_OPTIONS_UNITS_SPEED, knotUnit));

      pu.armor = static_cast<BUnits>(

        settings->readNumEntry(S_OPTIONS_UNITS_ARMOR, mmUnit));

      pu.caliber = static_cast<BUnits>(

        settings->readNumEntry(S_OPTIONS_UNITS_CALIBER, mmUnit));

    settings->endGroup();

  settings->endGroup();

  return pu;

}



QString BUiUtils::toString(const double value, 

  const BPresentationValues pValue, int options) {

  switch (pValue) {

  case coordinateValue:

    return BSeaMap::degreesToString(value, 

      static_cast<BSeaMap::BCoordinatesType>(options), true);

  case courseValue:

    {

      double angleDegrees = BUnitsConverter::angleToDegrees(value);

      int d, m, s, si;

      BUnitsConverter::angle(angleDegrees, &d, &m, &s, 0, &si);

      return QString("%1%2%3%4%5%6").arg(si*d).arg(QChar(176)).arg(

        m).arg("'").arg(

        s).arg("\"");

    }

  default:

    return QString::number(value);

  }

}



void BUiUtils::setPresentationUnits(const BPresentationUnits pUnits) {

  _pUnits = pUnits;

}

