/******************************************************************************/
/* BXmlConfig -   BattleFleet  (impl.)            */
/******************************************************************************/
static const char bxmlconfig_cpp_id[]="@(#) $Id: bxmlconfig.cpp,v 1.7 2005/04/10 14:29:39 Oleksiy Balabay Exp $"; static const char* bxmlconfig_cpp_id_id=bxmlconfig_cpp_id;

#include <qfile.h>
#include <qdom.h>

#include "bxmlconfig.h"
#include "bapplication.h"

/** \file bxmlconfig.cpp
  \brief  BXmlConfig  BattleFleet (impl.)

     BXmlConfig  BattleFleet
*/

/** \class BXmlConfig
  \brief         Xml

   fileName()    . 
  \a _doc  Dom-  .  
      Dom-   ; 
    ,       .

*/
/** \brief 
  
     \a fileName  ,    
    \a BattleFleet.

  \exception BException      . 
  BException::message()   .   
     

  \sa addFileName()
*/
BXmlConfig::BXmlConfig(const QString& fileName)
:_doc(0), _fileName(bApp->extendFileName(fileName)) {
  try{
    QFile f(_fileName);
    if (!f.exists()) {
      throw BConfigException(__FILE__, __LINE__,
        qApp->translate("BXmlConfig", "File does not exists"));
    }
    _doc = loadDocument(f);
  }
  catch(BConfigException& e) {
    throw addFileName(e);
  }
//  catch(BFileException& e) {
//    throw;
//  }
  catch(BException&) {
    throw;
  }
  catch(...) {
    throw BInternalException(__FILE__, __LINE__,
      qApp->translate("BXmlConfig",
      "Unknown error loading file '%1'").arg(_fileName));
  }
}

/** \brief 

   \a _doc,     
*/
BXmlConfig::~BXmlConfig(){
  if (_doc) {
    delete _doc;
    _doc = 0;
  }
}

QDomDocument* BXmlConfig::loadDocument(QFile& file) {
  QString errorMessage;
  int errorLine;
  int errorColumn;
  QDomDocument* doc = new QDomDocument();
  if (!doc->setContent(&file, &errorMessage, &errorLine, &errorColumn)) {
    delete doc;
    throw BFileException(BConfigException(__FILE__, __LINE__,
      qApp->translate("BXmlConfig","Error parsing file: '%1'").arg(
      errorMessage)), file.name(), errorLine, errorColumn);
  }
  return doc;
}

///     
BFileException BXmlConfig::addFileName(const BConfigException& e) {
  return BFileException(e, fileName());
}

///    
QString BXmlConfig::fileName() const {
  return _fileName;
}

/** \var BXmlConfig::_doc
  \brief Dom-   fileName()
*/

void BXmlConfig::save(const QString& fileName) const {
  QFile f(fileName);
  if (!f.open(IO_WriteOnly)) {
    // TODO:    
    throw BOutputException(__FILE__, __LINE__, fileName);
  }
  QTextStream t(&f);
  t.setEncoding(QTextStream::UnicodeUTF8);
  t << toXml().toString(2);
  f.close();
}

void BXmlConfig::setFileName(const QString& fileName) {
  _fileName = fileName;
}