/******************************************************************************/
/* BProperty -     (impl.)            */
/******************************************************************************/
static const char bproperty_cpp_id[]="@(#) $Id: bproperty.cpp,v 1.6 2004/10/14 17:44:55 Oleksiy Balabay Exp $"; static const char* bproperty_cpp_id_id=bproperty_cpp_id;

#include "bexception.h"
#include "bproperty.h"

/** \file bproperty.cpp
  \brief  BProperty   (impl.)

     BProperty  
*/

/** \class BProperty
  \brief 


*/
BProperty::BProperty(BPropertyTypes type, const QString& key,
  const QString& name, const QVariant& value, const QVariant& options)
  :_type(type), _key(key), _name(name), _value(value), _options(options),
  _editable(false) {
}

/** \brief 
*/
BProperty::~BProperty(){

}

BProperties::BProperties() {
}

BProperties::~BProperties() {
    clear();
}

void BProperties::clear() {
    for( int i = 0; i < static_cast<int>(_props.size()); i++) {
	delete _props[i];
    }
    _props.clear();
}

BProperty& BProperties::property(const QString& key) const{
    for( int i = 0; i < static_cast<int>(_props.size()); i++) {
	if (_props[i]->key() == key)
	    return *_props[i];
    }
    throw BInternalException(__FILE__, __LINE__,
	qApp->translate("BProperties",
	"Property with key '%1' not found").arg(key));
}

void BProperties::addProperty(BProperty* property){
    for( int i = 0; i < static_cast<int>(_props.size()); i++) {
	if (_props[i]->key() == property->key())
	    throw BInternalException(__FILE__, __LINE__,
		qApp->translate("BProperties",
		"Property with key '%1' already exists").arg(property->name()));
    }
    _props.push_back(property);
}
