/******************************************************************************/

/* BPropertyItems -   BattleFleet              */

/******************************************************************************/



#ifndef BPropertyItems_H

#define BPropertyItems_H

static const char bpropertyitems_h_id[]="@(#) $Id: bpropertyitems.h,v 1.1 2004/05/08 15:18:53 Oleksiy Balabay Exp $"; static const char* bpropertyitems_h_id_id=bpropertyitems_h_id;

/** \file bpropertyitems.h

*/

#include "propertyeditor.h"

#include "bseamap.h"



class BPropertyCourseItem : public QObject, public PropertyItem {

  Q_OBJECT

public:

  BPropertyCourseItem( PropertyList *l, PropertyItem *after, PropertyItem *prop, const QString &propName );

  ~BPropertyCourseItem();



  virtual void createChildren();

  virtual void initChildren();



  virtual void showEditor();

  virtual void hideEditor();



  virtual void setValue( const QVariant &v );

  virtual bool hasSubItems() const;

  virtual void childValueChanged( PropertyItem *child );



private:

  QGuardedPtr<QLineEdit> lined;

  QGuardedPtr<QHBox> box;

};



class BPropertyCoordinateItem : public QObject, public PropertyItem {

  Q_OBJECT

public:

  BPropertyCoordinateItem( PropertyList *l, PropertyItem *after, 

    PropertyItem *prop, const QString &propName, 

    BSeaMap::BCoordinatesType type);

  ~BPropertyCoordinateItem();



  virtual void createChildren();

  virtual void initChildren();



  virtual void showEditor();

  virtual void hideEditor();



  virtual void setValue( const QVariant &v );

  virtual bool hasSubItems() const;

  virtual void childValueChanged( PropertyItem *child );



private:

  QGuardedPtr<QLineEdit> lined;

  QGuardedPtr<QHBox> box;

  BSeaMap::BCoordinatesType _type;

};



#endif // BPropertyItems_H

