#!perl
use File::Copy;
if (-d "/etc") {
  $OS = "UNIX";
}
else {
  $OS = "WINDOWS";
}
if ($OS=~/WINDOWS/) {  
  $wHome = "C:/MyDoc/BattleFleet";
}
else {
  $wHome = "$ENV{HOME}/work/battlefleet";
}

$appName = "BattleFleet";
gen_lib();
gen_app();

sub gen_app() {
#   $appNameLow.pro     $appNameLow.dsp
#my $appNameLow;
print("\nCreating $appName...");
$appNameLow = lc($appName);
$appDir = "$wHome/src/$appNameLow";
chdir($appDir);
system("qmake -project DESTDIR=../.. ".
  "TEMPLATE=app CONFIG+=thread CONFIG+=qt CONFIG+=$ARGV[0] CONFIG+=warn_on ".
  "CONFIG+=exceptions CONFIG+=rtti CONFIG+=stl CONFIG-=flat".
  "OBJECTS_DIR=$ARGV[0] ".
  "INCLUDEPATH+=../bmath ".
  "win32:LIBS+=../../bmath.lib ".
  "linux-g++:LIBS+=-L../.. ".
  "linux-g++:LIBS+=-lbmath ".
  "LIBS+=-lqassistantclient ".
  "TRANSLATIONS=$appNameLow"."_ru".".ts RC_FILE+=$appNameLow.rc ".
  "IMAGES+=images/splash.jpg ".
  "IMAGES+=images/battlefleet.png ".                                                      
  "IMAGES+=images/zoomin.png ".                                                      
  "IMAGES+=images/zoomout.png ".
  "IMAGES+=images/scale.png ".
  "IMAGES+=images/select.png ".
  "IMAGES+=images/group.png ".
  "IMAGES+=images/ungroup.png ".
  "IMAGES+=images/order.png ".
  "IMAGES+=images/battleship0.bmp ".
  "IMAGES+=images/battleship1.bmp ".
  "IMAGES+=images/battleship2.bmp ".
  "IMAGES+=images/armoredcruiser0.bmp ".
  "IMAGES+=images/armoredcruiser1.bmp ".
  "IMAGES+=images/armoredcruiser2.bmp ".
  "IMAGES+=images/cruiser0.bmp ".
  "IMAGES+=images/cruiser1.bmp ".
  "IMAGES+=images/cruiser2.bmp ".
  "IMAGES+=images/destroyer0.bmp ".
  "IMAGES+=images/destroyer1.bmp ".
  "IMAGES+=images/destroyer2.bmp ".
  "IMAGES+=images/torpedoboat0.bmp ".
  "IMAGES+=images/torpedoboat1.bmp ".
  "IMAGES+=images/torpedoboat2.bmp ".
  "IMAGES+=images/ship0.bmp ".
  "IMAGES+=images/ship1.bmp ".
  "IMAGES+=images/ship2.bmp ".
  "IMAGES+=images/fullview.png ".
  "IMAGES+=images/connect.png ".
  "IMAGES+=images/show_connections.png ".
  "IMAGES+=images/hide_connections.png ".
  "IMAGES+=images/manual.png ".
  "IMAGES+=images/auto.png ".
  "IMAGES+=propertylist/images/designer_resetproperty.png "
);

if ($OS=~/WINDOWS/) {  
  system("qmake -win32 -t vcapp $appNameLow.pro");
}
else {
  system("qmake -t app $appNameLow.pro");
}
system("lupdate $appNameLow.pro");
system("lrelease $appNameLow.pro");
unlink("../../${appNameLow}_ru.qm");
move("${appNameLow}_ru.qm", "../../${appNameLow}_ru.qm");
print(" Done.\n");
}

sub gen_lib() {
#    bmath
$libName = "BMath";
print ("\nCreating $libName library...");
$libNameLow = lc($libName);
$libDir = "$wHome/src/$libNameLow";
chdir($libDir);
system("qmake -project DESTDIR=../.. ".
  "TEMPLATE=lib CONFIG+=thread CONFIG+=qt CONFIG-=moc CONFIG+=$ARGV[0] CONFIG+=warn_on ".
  "CONFIG+=exceptions CONFIG+=rtti CONFIG+=stl CONFIG+=dll ".
  "DEFINES+=BMATH_DLL ".
  "DEFINES-=UNICODE ".
  "OBJECTS_DIR=$ARGV[0] ".
  "win32:QMAKE_LFLAGS+=/DEF:$libNameLow.def " #.
#  "TRANSLATIONS=$libNameLow.ts"
);
if ($OS=~/WINDOWS/) {  
  system("qmake -win32 -t vclib $libNameLow.pro");
}
else {
  system("qmake -t lib $libNameLow.pro");
}
print(" Done.\n");
}
