/******************************************************************************/
/* BCFinder -                 */
/******************************************************************************/

#ifndef BCFinder_H
#define BCFinder_H
static const char bcfinder_h_id[]="@(#) $Id: bcfinder.h,v 1.1 2005/01/09 14:27:06 Oleksiy Balabay Exp $"; static const char* bcfinder_h_id_id=bcfinder_h_id;
/** \file bcfinder.h
  \brief  BCFinder  

     BCFinder  
*/
#include "bmath.h"
#include "bpathfinder.h"

class TestGoTo;

class BMATH_EXPORT BCFinder: public BFinder {
  friend class TestGoTo;
public:
  BCFinder();
  virtual ~BCFinder();
  PathFinderOutput findPath(const PathFinderInput& pInput);
private:
  /// 
  void transformToAO();
  void transformToBC();
  bool check1() const;
  void calcAC();
  void calcO1();
  void calcO2();
  bool check2() const;
  void calcAngle1();
  void calcAngle2();
  void calcLength();
  PathProgramDatas addTurnPrograms(const PathProgramDatas& vv);
private:
  PathFinderInput _input;
  PathFinderInput _inputAO;
  QWMatrix _mAO;
  PathFinderInput _inputBC;
  QWMatrix _mBC;
  //   .   . . BC
  double _xAC, _yAC;
  //  .  
  double _xO1, _yO1;
  //  .  
  double _xO2, _yO2;
  double _angle1;
  double _angle2;
  double _l1;
  double _l2;
  double _l3;
};

extern "C" {
  BMATH_EXPORT BFinder::PathFinderOutput findCPath(
    const BFinder::PathFinderInput& pInput);
}

#endif // BCFinder_H
