/******************************************************************************/
/* BMathTurn -               */
/******************************************************************************/

#ifndef BMathTurn_H
#define BMathTurn_H

#include "bmath.h"

static const char bmathturn_h_id[]="@(#) $Id: bmathturn.h,v 1.3 2005/01/14 16:20:42 Oleksiy Balabay Exp $"; static const char* bmathturn_h_id_id=bmathturn_h_id;

extern "C" {
#ifdef Q_WS_WIN
 bool __stdcall bf_turn_accelerate(
#endif
#ifdef Q_WS_X11
 bool bf_turn_accelerate(
#endif
   double* x ,
   double* y,
   double* c,
   double* v,
   double* vcomp,
   double* a,
   double* r,
   double t,
   double angle,
   double v_0,
   double v_k,
   double r_c,
   double a_max,
   double k_v /**/);
}
  
struct BMATH_EXPORT BPoint {
  double x;
  double y;
  double c;
  double v;
  double vcomp;
  double a;
  double r;
};

struct BMATH_EXPORT BTurnAccelerateInput {
  double t;
  double angle;
  double v_0;
  double v_k;
  double r_c;
  double a_max;
  double k_v;
};

extern "C" {
  BMATH_EXPORT BPoint turnAccelerate(const BTurnAccelerateInput& in);
}

extern double root2(double a, double b, double c, double ll, double hl);

#endif // BMathTurn_H
