#include <qwidgetplugin.h>

#include "../battlefleet/bscrollbar.h"

class BScrollBarPlugin : public QWidgetPlugin
{
public:
    QStringList keys() const;
    QWidget *create(const QString &key, QWidget *parent,
                    const char *name);
    QString includeFile(const QString &key) const;
    QString group(const QString &key) const;
    QIconSet iconSet(const QString &key) const;
    QString toolTip(const QString &key) const;
    QString whatsThis(const QString &key) const;
    bool isContainer(const QString &key) const;
};

QStringList BScrollBarPlugin::keys() const
{
    return QStringList() << "BScrollBar";
}

QWidget *BScrollBarPlugin::create(const QString &, QWidget *parent,
                                  const char *name)
{
    return new BScrollBar(parent, name);
}

QString BScrollBarPlugin::includeFile(const QString &) const
{
    return "bscrollbar.h";
}

bool BScrollBarPlugin::isContainer(const QString &) const
{
    return false;
}

QString BScrollBarPlugin::group(const QString &) const
{
    return "Plugin Widgets";
}

QIconSet BScrollBarPlugin::iconSet(const QString &) const
{
    return QIconSet(QPixmap::fromMimeSource("bscrollbar.png"));
}

QString BScrollBarPlugin::toolTip(const QString &) const
{
    return "Smart scrollbar";
}

QString BScrollBarPlugin::whatsThis(const QString &) const
{
    return "Widget for creating smart scrollbars";
}

Q_EXPORT_PLUGIN(BScrollBarPlugin)
